/**
 * Created by wy on 2017 
 */
define(function(require, exports) {

	//公用类
	var common = require('common');
	//侧栏菜单
	var leftmenu = require('leftmenu');
	//用户ID
	var locuserid = localStorage.getItem('userid');

	//获取用户已经选择的单词分类筛选规则
	var userclassify = localStorage.getItem('wordclassifydata');
	
	var word = function(e, id, page) {
		this.page = page;
		//侧栏菜单
		if(locuserid == null) {
			this.page.find('.open-panel').on('click', function() {
				$.toast('更多功能在登录之后回来');
				setTimeout(function() {
					$.router.load('../index.html');
				}, 3000);
			});
		} else {
			leftmenu.showmenu(this.page);
		}

		//页面加载
		this.PageLoad();
	};

	//页面加载
	word.prototype.PageLoad = function() {
		var that = this;
		var baseurl = localStorage.getItem('base');
		/* var baseurl = "localhost:8080/mobileMta";  */
		common.get('/getWordClassify.html', function(res) {
			var html = [];
			html.push(' <li class="item-content active">全部</li>');
			if(res.length > 0) {
				for(var i = 0; i < res.length; i++) {
					html.push('<li class="item-content" classifyid="' + res[i].classifyid + '">' + res[i].name + '</li>');
				}
			}
			$("#wordTypeUl").html(html.join(''));
	//点击分类选项，本地存储用户选择的筛选规则
		that.clickli();
		})
	};

	//点击分类选项，本地存储用户选择的筛选规则
	word.prototype.clickli = function() {
		var that = this,
			wordclassifydata = {};
		if(userclassify != null) {
			var data = JSON.parse(userclassify);
			var lastchoosetype = data.classifyid;
			$("#wordTypeUl").find('li').removeClass('active');
			$("#wordTypeUl").find("li[classifyid='" + lastchoosetype + "']").addClass('active');
		}
		var clickLi = $("#wordTypeUl").find('li');
		//先解绑定click事件再绑定click事件
		clickLi.off('click').on('click', function() {

			$("#wordTypeUl").find('li').removeClass('active');
			$(this).addClass('active');

			var type = $(this).attr('classifyid');
			wordclassifydata.classifyid = type;
			localStorage.setItem('wordclassifydata', JSON.stringify(wordclassifydata));
			/*$.router.load('word.html', true);*/
		});
	};

	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.data('page');

		if(!obj) {
			obj = new word(e, id, $page);
		} else {
			$page.data('page', obj);
		}
		return obj;
	};
});