/**
 * Created by wy on 2017 
 */
//json数据

define(function(require, exports) {

	//公用类
	var common = require('common');
	//侧栏菜单
	var leftmenu = require('leftmenu');
	//用户ID
	var locuserid = localStorage.getItem('userid');

	//获取用户已经选择的单词分类筛选规则
	var userclassify = localStorage.getItem('wordclassifydata');
	//	console.log(userclassify)
	//获取用户已经学习到第几个单词，下次进入背单词页面从第n个单词开始记
	/*	localStorage.setItem('practiceWordId', 6);*/
	var practiceWordId = localStorage.getItem('practiceWordId');
	console.log(practiceWordId)
	var wordPrictise = function(e, id, page) {
		this.page = page;
		this.wordPracticeContent = page.find('#wordPracticeContent');
		//单词显示
		this.danci = page.find('#danci');
		//音标显示
		this.yinbiao = page.find('#yinbiao');
		//中文翻译内容
		this.zhongwenfanyi = page.find('#zhongwenfanyi');
		//英文翻译内容
		this.yingwenfanyi = page.find('#yingwenfanyi');
		//例句内容
		this.liju = page.find('#liju');
		//下一个单词按钮
		this.nextwordBtn = page.find('#nextwordBtn');
		//上一个单词按钮
		this.prewordBtn = page.find('#prewordBtn');

		//播放喇叭
		this.speakerIcon = page.find('#speaker-icon');

		//侧栏菜单
		if(locuserid == null) {
			this.page.find('.open-panel').on('click', function() {
				$.toast('更多功能在登录之后回来');
				setTimeout(function() {
					$.router.load('../index.html');
				}, 3000);
			});
		} else {
			leftmenu.showmenu(this.page);
		}

		//页面加载
		this.PageLoad();
	};

	//页面加载
	wordPrictise.prototype.PageLoad = function() {
		var that = this;

		//加载音频
		/* var audioHtml = [];
		 for(var i = 0;i<res.total;i++){
		 	audioHtml.push('<audio src="'+res.rows[i].audioUrl+'"></audio>');
		 }
		 that.speakerIcon.html(audioHtml.join(''));*/
		//加载单词
		//		if(practiceWordId == null) {
		//			that.loadNextWords(0);
		//		} 
		//	    else {
		//			that.loadNextWords(practiceWordId);
		//		}
		//		if(practiceWordId != null && practiceWordId != '0') {
		//			$.modal({
		//				extraClass: 'tipcard',
		//				title: '<div class="tipcard-title">温馨提示</div>',
		//				text: '<div class="tipcard-cotent">' +
		//					'<p>是否继续背单词?</p>' +
		//					'<div class="row">' +
		//					'<a class="button-big button-fill button col-50 cancel" id="tipbtncancel">是</a>' +
		//					'<a class="button-big button-fill button col-50 start" id="tipbtnupdata">否</a>' +
		//					'</div>'
		//			});
		//		} else {
		//			that.loadNextWords(0);
		//		}
		that.loadNextWords(0);

		$('#tipbtncancel').off('click').on('click', function() {
			$.closeModal('.tipcard');
			that.loadCurWord(practiceWordId);
		});
		$('#tipbtnupdata').off('click').on('click', function() {
			$.closeModal('.tipcard');
			that.loadNextWords(0);
		});
		//点击下一个按钮
		that.clicknextwordBtn();

		//点击上一个按钮
		that.clickprewordBtn();

	};

	var scrdata = {};

	if(userclassify != null) {
		var classifyid = JSON.parse(userclassify).classifyid;
		scrdata = {
			classifyid: classifyid
		};
	}

	//显示当前单词
	wordPrictise.prototype.loadCurWord = function(practiceWordId) {
		var that = this;
		that.loadhtml('/getCurrentWord.html', practiceWordId);
	};

	//显示下一个单词
	wordPrictise.prototype.loadNextWords = function(practiceWordId) {
		var that = this;
		that.loadhtml('/getNextWord.html', practiceWordId);
	};

	//显示上一个单词
	wordPrictise.prototype.loadPreWords = function(practiceWordId) {
		var that = this;
		that.loadhtml('/getPreWord.html', practiceWordId);
	};
	//点击下一个单词
	wordPrictise.prototype.clicknextwordBtn = function() {
		var that = this;
		that.nextwordBtn.on('click', function() {
			if($(this).hasClass('off')) { // 判断当前元素是否有off的类，如果有则不继续向下执行
				return;
			} else {
				that.prewordBtn.removeClass('off');
			}
			//加载单词
			var practiceWordId = localStorage.getItem('practiceWordId');
			that.loadNextWords(practiceWordId);

		});

	}

	//点击上一个单词
	wordPrictise.prototype.clickprewordBtn = function() {
		var that = this;
		that.prewordBtn.off('click').on('click', function() {
			if($(this).hasClass('off')) { // 判断当前元素是否有off的类，如果有则不继续向下执行
				return;
			}
			//加载单词
			var practiceWordId = localStorage.getItem('practiceWordId');
			that.loadPreWords(practiceWordId);
		});

	}

	wordPrictise.prototype.loadhtml = function(url, practiceWordId) {
		var that = this;
		/* practiceWordId = (practiceWordId) ? practiceWordId : 0;*/
		var userclassify = localStorage.getItem('wordclassifydata');
		var classifyid = JSON.parse(userclassify).classifyid;
		if(userclassify != null) {
			scrdata = {
				classifyid: classifyid,
				id: practiceWordId
			};
		} else {
			scrdata = {
				id: practiceWordId
			};
		}

		var that = this,
			text, data, zhongwenfanyi = [],
			liju = [],
			nextwordData;
		that.prewordBtn.addClass('active');
		that.nextwordBtn.addClass('active');
		var baseurl = localStorage.getItem('base');
		common.get(url, scrdata, function(res) {
						console.log(res)
			if(res != "" && res) {
				that.danci.html(res.name);
				that.yinbiao.html(res.phonogram);
				console.log(res.sentence)
				that.speakerIcon.find('audio').prop('src', baseurl + res.pronunciation);
				//词性&词义
				var s = [];
				var t = [];
				if(res.partofspeech.indexOf("|") !== -1) {
					s = res.partofspeech.split("|");
					t = res.acceptation.split("|");
				} else {
					s = res.partofspeech.split(/[\r\n]/g);
					t = res.acceptation.split(/[\r\n]/g);
				}
				var ciyi = '';
				for(var i = 0; i < s.length; i++) {
					ciyi += '<li>' + s[i] + t[i] + '</li>'
				}
				zhongwenfanyi.push(ciyi);
				that.zhongwenfanyi.html(zhongwenfanyi.join(''));

				//例句
				liju.push('<div class="example"><ul>');
				var liju_ary = res.sentence.split("。");
				for(var r = 0; r < liju_ary.length - 1; r++) {
					var str0 = liju_ary[r].trim().substring("0", "5");
					var str = liju_ary[r].trim().substring("5");
					var index = liju_ary[r].trim().substring("5").indexOf(".");
					if(index > 5) {
						var str1 = str.replace('.', '.<br/>');
						liju.push('<li>' + str0 + str1 + '。</li>');
					} else {
						liju.push('<li>' + liju_ary[r] + '。</li>');
					}

				}
				liju.push('</ul></div>');
				that.liju.html(liju.join(''));

				//				liju.push('<div class="example"><ul><li>' + res.sentence + '</li></ul></div>')
				//				that.liju.html(liju.join(''));

				localStorage.setItem('practiceWordId', res.id);
				var wordclassifydata = {};
				wordclassifydata.classifyid = res.classifyid;
				localStorage.setItem('wordclassifydata', JSON.stringify(wordclassifydata));
				console
				//判断是否是第一个单词或者是最后一个单词
				if(classifyid != null) {
					nextwordData = {
						classifyid: classifyid,
						id: res.id
					};
				} else {
					nextwordData = {
						id: res.id
					};
				}
				
				common.get('/getPreWord.html', nextwordData, function(res) {
					if(res.length == 0) {
						that.prewordBtn.removeClass('active');
						that.prewordBtn.addClass('off');
						that.nextwordBtn.removeClass('off');
					}
				})
				common.get('/getNextWord.html', nextwordData, function(res) {
					if(res.length == 0) {
						that.nextwordBtn.removeClass('active');
						that.prewordBtn.removeClass('off');
						that.nextwordBtn.addClass('off');
					}
				})
				//点击喇叭，播放音频
				that.mediaStart();
			} else {
				that.wordPracticeContent.html('<div class="nomsg">此分类暂无单词</div>')
			}

		});
	}

	//点击喇叭，播放音频
	wordPrictise.prototype.mediaStart = function() {
		var that = this;
		that.speakerIcon.off('click').on('click', function() {
			$(this).addClass('off');
			that.speakerIcon.on('click', function() {
				if($(this).hasClass('off')) { // 判断当前元素是否有off的类，如果有则不继续向下执行
					return;
				}
			});

			var $this = $(this),
				$audio = $this.find("audio");
			/*$this.removeClass('off');*/
			$audio.get(0).play();
			//获取音频时长
			var duration = $audio.attr('duration');
			var startId = setInterval(function() {
				$this.toggleClass('toggle');
			}, 1000); //1000为1秒钟

			setTimeout(function() {
				$this.removeClass().addClass('speaker-icon');
				$this.removeClass('off');
				clearInterval(startId);
			}, duration * 1000)
		})

	}

	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.data('page');

		if(!obj) {
			obj = new wordPrictise(e, id, $page);
		} else {
			$page.data('page', obj);
		}
		return obj;
	};
});