/**
 * Created by wy on 2017 
 */

define(function(require, exports) {

	//公用类
	var common = require('common');
	//侧栏菜单
	var leftmenu = require('leftmenu');
	//用户ID
	var locuserid = localStorage.getItem('userid');

	//获取用户已经选择的单词分类筛选规则
	var userclassify = localStorage.getItem('wordclassifydata');

	//获取用户已经学习到第几个单词，下次进入背单词页面从第n个单词开始记
	/*	localStorage.setItem('testWordId', 5);*/
	var testWordId = localStorage.getItem('testWordId');
	console.log(testWordId);

	var wrongArry;

	common.get("/getWordWrong.html", {
		userid: locuserid
	}, function(res) {
		console.log(res)
		if(res !== "") {
			wrongArry = res.wordids.split(",");
		} else {
			wrongArry = [];
		}
	})

	//	if(localStorage.getItem('wrongArry')) {
	////		console.log(localStorage.getItem('wrongArry'))
	//		wrongArry = localStorage.getItem('wrongArry').split(",");
	//	} else {
	//		wrongArry = [];
	//	}

	var wordTest = function(e, id, page) {

		this.page = page;
		this.wordTestContent = page.find('#wordTestContent');

		//输入单词的div 
		this.wordinput = page.find('#wordinput');

		//单词显示
		this.danci = page.find('#danci');

		//音标显示
		this.yinbiao = page.find('#yinbiao');

		//中文翻译内容
		this.zhongwenfanyi = page.find('#zhongwenfanyi');
		//英文翻译内容
		this.yingwenfanyi = page.find('#yingwenfanyi');
		//例句内容
		this.liju = page.find('#liju');

		//获取提交答案按钮
		this.wordtestBtn = page.find('#wordtestBtn');

		//获取“下一个”按钮
		this.nextwordtestBtn = page.find('#nextwordtestBtn');

		//显示正确答案区域
		this.wordtestanswer = page.find('#wordtestanswer');

		//学员输入的答案
		this.useranswer = page.find('#useranswer');

		//播放喇叭
		this.speakerIcon = page.find('.speaker-icon');

		//侧栏菜单
		if(locuserid == null) {
			this.page.find('.open-panel').on('click', function() {
				$.toast('更多功能在登录之后回来');
				setTimeout(function() {
					$.router.load('../index.html');
				}, 3000);
			});
		} else {
			leftmenu.showmenu(this.page);
		}

		//页面加载
		this.PageLoad();
	};

	//页面加载
	wordTest.prototype.PageLoad = function() {
		var that = this;

		//加载单词
		/*if(testWordId == null) {
			that.loadNextWords(0);
		} else {
		that.loadNextWords(testWordId);
		}
*/
		if(testWordId != null && testWordId != '0') {
			$.modal({
				extraClass: 'tipcard',
				title: '<div class="tipcard-title">温馨提示</div>',
				text: '<div class="tipcard-cotent">' +
					'<p>是否继续上轮测试?</p>' +
					'<div class="row">' +
					'<a class="button-big button-fill button col-50 cancel" id="tipbtncancel">是</a>' +
					'<a class="button-big button-fill button col-50 start" id="tipbtnupdata">否</a>' +
					'</div>'
			});
		} else {
			that.loadNextWords(0);
		}
		$('#tipbtncancel').off('click').on('click', function() {
			$.closeModal('.tipcard');
			that.loadCurWord(testWordId);
		});
		$('#tipbtnupdata').off('click').on('click', function() {
			$.closeModal('.tipcard');
			that.loadNextWords(0);
		});
		//显示正确答案
		that.showAnswer();
		//点击喇叭，播放音频
		that.mediaStart();
	};

	/*var scrdata = {};

	if(classifyid != null) {
		var classifyid = JSON.parse(userclassify).classifyid;
		scrdata = {
			classifyid: classifyid
		};
	}*/

	//显示当前单词
	wordTest.prototype.loadCurWord = function(testWordId) {
		var that = this;
		that.loadtestWords('/getCurrentWord.html', testWordId);
	};

	//显示下一个单词
	wordTest.prototype.loadNextWords = function(testWordId) {
		var that = this;
		that.loadtestWords('/getNextWord.html', testWordId);
	};

	//单词显示
	wordTest.prototype.loadtestWords = function(url, testWordId) {
		/*testWordId = (testWordId) ? testWordId : 0;*/
		if(userclassify != null) {
			var classifyid = JSON.parse(userclassify).classifyid;
			scrdata = {
				classifyid: classifyid,
				id: testWordId
			};
		} else {
			scrdata = {
				id: testWordId
			};
		}
		var that = this,
			text, data, zhongwenfanyi = [],
			liju = [];

		var baseurl = localStorage.getItem('base');
		//		console.log(url );
		//		console.log(scrdata);
		common.get(url, scrdata, function(res) {

			//common.get('/getCurrentWord.html', scrdata, function(res) {	
			console.log(res);
			if(res != "" && res) {
				that.danci.html(res.acceptation);
				$("#wordAnswer").html(res.name);
				that.yinbiao.html(res.phonogram);
				$(that.speakerIcon).find('audio').prop('src', baseurl + "/" + res.pronunciation);
				zhongwenfanyi.push('<li><span>' + res.partofspeech + '</span>' + res.acceptation + '</li>');
				that.zhongwenfanyi.html(zhongwenfanyi.join(''));
				//例句
				console.log(res.sentence)
				liju.push('<div class="example"><ul><li>' + res.sentence + '</li></ul></div>')
				that.liju.html(liju.join(''));
				localStorage.setItem('testWordId', res.id);
				//判断是否是第一个单词或者是最后一个单词
				if(classifyid != null) {
					nextwordData = {
						classifyid: classifyid,
						id: res.id
					};
				} else {
					nextwordData = {
						id: res.id
					};
				}
				common.get('/getNextWord.html', nextwordData, function(res) {
					if(res.length == 0) {
						that.nextwordtestBtn.off('click');
						that.nextwordtestBtn.find('span').html("已经是最后一题");
					}
				})
				//换下一题
				that.showNext();
			} else {
				that.wordTestContent.html('<div class="nomsg">此分类暂无单词</div>');
				localStorage.setItem('testWordId', '0');

			}

		})
	};

	//单词提交
	wordTest.prototype.showAnswer = function() {
		var that = this,
			text, rightanswer;

		that.wordtestBtn.off('click').on('click', function() {
			text = that.useranswer.val();
			rightanswer = $("#wordAnswer").html();
			that.wordtestanswer.show();
			that.wordtestBtn.parent().hide();
			that.nextwordtestBtn.parent().show();

			that.wordinput.addClass('searchbar-active');
			//校验答案是否正确
			var wrongstr;
			var wordtestId = localStorage.getItem('testWordId');
			if(text == rightanswer) {
				that.wordinput.addClass('rightanswer')
				for(var i = 0; i < wrongArry.length; i++) {				
					if(wordtestId == wrongArry[i]) {
						wrongArry.splice(i, 1);
					}
				}
				wrongstr = wrongArry.join(",")
			} else {
				//判断该单词是否存在于错题数组中
				for(var i = 0; i < wrongArry.length; i++) {					
					if(wordtestId == wrongArry[i]) {
						wrongArry.splice(i, 1);
					}
				}
				wrongArry.push(wordtestId);
				wrongstr = wrongArry.join(",")
				//				localStorage.setItem('wrongArry', wrongArry);
				that.wordinput.addClass('wrong')
			}

			var word_data = {
				userid: locuserid,
				wordids: wrongstr
			}
			common.get("/saveWordWrong.html", word_data, function(res) {
				console.log(res)
			})

		});
	};

	wordTest.prototype.showNext = function() {
		var that = this,
			text, data;

		that.nextwordtestBtn.off('click').on('click', function() {
			that.wordtestanswer.hide();
			that.wordtestBtn.parent().show();
			that.nextwordtestBtn.parent().hide();
			//清空搜索情况
			that.useranswer.val("");
			that.wordinput.removeClass().addClass('searchbar');

			//加载单词
			var wordtestId = localStorage.getItem('testWordId');
			localStorage.setItem('testWordId', wordtestId);
			that.loadNextWords(wordtestId);
		});

	};

	//点击喇叭，播放音频
	wordTest.prototype.mediaStart = function() {
		var that = this;
		that.speakerIcon.off('click').on('click', function() {
			var $this = $(this),
				$audio = $this.find("audio");
			$audio.get(0).play();
		})

	}

	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.data('page');

		if(!obj) {
			obj = new wordTest(e, id, $page);
		} else {
			$page.data('page', obj);
		}
		return obj;
	};
});