/**
 * Created by wy on 2017 
 */
//json数据
define(function(require, exports) {

	//公用类
	var common = require('common');
	//侧栏菜单
	var leftmenu = require('leftmenu');
	//用户ID
	var locuserid = localStorage.getItem('userid');
	//记录错题库的数组
	var wrongArry;
	var wrongNum = 0;
//	common.get("/getWordWrong.html", {
//		userid: locuserid
//	}, function(res) {
//		console.log(res)
//		if(res !== "") {
//			wrongArry = res.wordids.split(",");
//		} else {
//			wrongArry = [];
//		}
//		wrongNum = wrongArry.length;
//	})

	//	if(localStorage.getItem('wrongArry')) {
	//		console.log(localStorage.getItem('wrongArry'))
	//		wrongArry = localStorage.getItem('wrongArry').split(",");
	//	} else {
	//		wrongArry = [];
	//	}

	//	var wrongNum = wrongArry.length;

	var wrongWord = function(e, id, page) {
		this.page = page;
		//单词显示
		this.danci = page.find('#danci');
		//音标显示
		this.yinbiao = page.find('#yinbiao');
		//中文翻译内容
		this.zhongwenfanyi = page.find('#zhongwenfanyi');
		//英文翻译内容
		this.yingwenfanyi = page.find('#yingwenfanyi');
		//例句内容
		this.liju = page.find('#liju');
		//下一个单词按钮
		this.nextwordBtn = page.find('#nextwordBtn');
		//上一个单词按钮
		this.prewordBtn = page.find('#prewordBtn');

		//播放喇叭
		this.speakerIcon = page.find('#speaker-icon');

		//侧栏菜单
		if(locuserid == null) {
			this.page.find('.open-panel').on('click', function() {
				$.toast('更多功能在登录之后回来');
				setTimeout(function() {
					$.router.load('../index.html');
				}, 3000);
			});
		} else {
			leftmenu.showmenu(this.page);
		}

		//页面加载
		this.PageLoad();
	};

	//页面加载
	//i记录错题数组中第n个数据
	var i = 0;
	wrongWord.prototype.PageLoad = function() {
		var that = this;
		that.loadCurWord();
		//点击下一个按钮
		that.clicknextwordBtn();

		//点击上一个按钮
		that.clickprewordBtn();

	};

	var scrdata = {};

	//显示当前单词
	wrongWord.prototype.loadCurWord = function() {
		var that = this;
		that.loadhtml('/getCurrentWord.html');
	};

	//点击下一个单词
	wrongWord.prototype.clicknextwordBtn = function() {
		var that = this;
		that.nextwordBtn.on('click', function() {
			if($(this).hasClass('off')) { // 判断当前元素是否有off的类，如果有则不继续向下执行
				return;
			}
			//加载单词
			i++;
			that.loadCurWord();
		});

	}

	//点击上一个单词
	wrongWord.prototype.clickprewordBtn = function() {
		var that = this;
		that.prewordBtn.off('click').on('click', function() {
			if($(this).hasClass('off')) { // 判断当前元素是否有off的类，如果有则不继续向下执行
				return;
			}
			//加载单词
			i--;
			that.loadCurWord();
		});

	}

	wrongWord.prototype.loadhtml = function(url) {
		var that = this;
		common.get("/getWordWrong.html", {
			userid: locuserid
		}, function(wordres) {
			console.log(wordres)
			if(wordres.wordids !== "") {
				wrongArry = wordres.wordids.split(",");
			} else {
				wrongArry = [];
			}
			wrongNum = wrongArry.length;
			
			console.log(wrongNum)
			
			if(wrongNum == 0) {
				$("#wrongWordContent").html("<p>没有错词</p>")
			} else {
				scrdata = {
					id: wrongArry[i]
				};

				var text, data, zhongwenfanyi = [],
					liju = [];
				that.prewordBtn.addClass('active');
				that.nextwordBtn.addClass('active');
				var baseurl = localStorage.getItem('base');
				common.get(url, scrdata, function(res) {
					that.danci.html(res.name);
					that.yinbiao.html(res.phonogram);
					that.speakerIcon.find('audio').prop('src', baseurl + res.pronunciation);
					//翻译
					zhongwenfanyi.push('<li><span>' + res.partofspeech + '</span>' + res.acceptation + '</li>');
					that.zhongwenfanyi.html(zhongwenfanyi.join(''));
					//例句
					liju.push('<div class="example"><ul><li>' + res.sentence + '</li></ul></div>')
					that.liju.html(liju.join(''));
					if(i == 0 && i == parseInt(wrongArry.length - 1)) {
						that.prewordBtn.addClass('off');
						that.nextwordBtn.addClass('off');
						that.prewordBtn.removeClass('active');
						that.nextwordBtn.removeClass('active');
					} else {
						if(i == 0) {
							that.prewordBtn.removeClass('active');
							that.prewordBtn.addClass('off');
							that.nextwordBtn.removeClass('off');
						}
						if(i == parseInt(wrongArry.length - 1)) {
							that.nextwordBtn.removeClass('active');
							that.prewordBtn.removeClass('off');
							that.nextwordBtn.addClass('off');
						}
					}

					//点击喇叭，播放音频
					that.mediaStart();
				});
			}
		})
	}

	//点击喇叭，播放音频
	wrongWord.prototype.mediaStart = function() {
		var that = this;
		that.speakerIcon.off('click').on('click', function() {
			alert("播放");
			$(this).addClass('off');
			that.speakerIcon.on('click', function() {
				if($(this).hasClass('off')) { // 判断当前元素是否有off的类，如果有则不继续向下执行
					return;
				}
			});

			var $this = $(this),
				$audio = $this.find("audio");
			/*$this.removeClass('off');*/

			$audio.get(0).play();
			//获取音频时长
			var duration = $audio.attr('duration');
			var startId = setInterval(function() {
				$this.toggleClass('toggle');
			}, 1000); //1000为1秒钟

			setTimeout(function() {
				$this.removeClass().addClass('speaker-icon');
				$this.removeClass('off');
				clearInterval(startId);
			}, duration * 1000)
		})

	}

	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.data('page');

		if(!obj) {
			obj = new wrongWord(e, id, $page);
		} else {
			$page.data('page', obj);
		}
		return obj;
	};
});