/**
 * Created by X01 on 2016-06-13.
 */
define(function(require, exports) {

	//公用类
	var common = require('common');
	//用户ID
	var locuserid = localStorage.getItem('userid');
	//课件ID
	var kjid = window.location.href.split('?')[1].split('&&')[0].split('=')[1];
	//课程UUID
	var kcuuid = window.location.href.split('?')[1].split('&&')[1].split('=')[1];
	//音频时长
	var timeLength = window.location.href.split('?')[1].split('&&')[2].split('=')[1];

	var baseurl = localStorage.getItem('base');
	/* var baseurl = "http://localhost:8080";*/
	var videolearn = function(e, id, page) {
		this.page = page; //页面

		//页面标题
		this.btnback = page.find('#btnback');
		//页面标题
		this.pagetitle = page.find('#pagetitle');
		//播放器
		this.video = page.find('#video');
		//播放器
		this.player = page.find('#player');
		//课程目录列表
		this.studylist = page.find('#studylist');
		//课程简介
		this.coursedes = page.find('#coursedes');
		//课程适用对象
		this.fitobject = page.find('#fitobject');
		//课程评论列表
		this.commentlist = page.find('#commentlist');
		//课程考试列表
		this.testlist = page.find('#testlist');
		//轮播
		this.config = {
			autoplay: 3000,
			speed: 1000
		};

		//页面呈现
		this.PageLoad();

	};

	//页面呈现
	videolearn.prototype.PageLoad = function() {
		var that = this;
		var slhtml = [];
		var comhtml = [];

		common.get('/coursePlay.html', {
			uuid: kcuuid,
			userid: locuserid
		}, function(res) {
			if(res.errorMsg == -1) {
				$.toast('开始时间未到');
				setTimeout(function() {
					$.router.load('item.html?uuid=' + kcuuid);
				}, 3000);
			} else if(res.errorMsg == -2) {
				$.toast('结束时间已过');
				setTimeout(function() {
					$.router.load('item.html?uuid=' + kcuuid);
				}, 3000);
			} else if(res.errorMsg == -3) {
				$.toast('数据错误');
				setTimeout(function() {
					$.router.load('item.html?uuid=' + kcuuid);
				}, 3000);
			} else {
				var chapter = res.data.chapterInfo;

				if(chapter.length > 0) {
					for(var i = 0; i < chapter.length; i++) {
						var logs = chapter[i];

						slhtml.push('<li class="item-content">第' + (i + 1) + '章 ' + logs.chapterName + '</li>');

						for(var log = 0; log < logs.section.length; log++) {
							slhtml.push('<li class="item-content">第' + (log + 1) + '节 ' + logs.section[log].sectionName + '</li>');
							for(var kj = 0; kj < logs.section[log].kejian.length; kj++) {
								var kjarr = logs.section[log].kejian[kj];

								if(kjarr.coursewareId == kjid) {
									slhtml.push('<li class="active">');

									document.title = logs.section[log].kejian[kj].name;
									that.pagetitle.html(logs.section[log].kejian[kj].name);
									var type = kjarr.type;
									// 判断课件类型，如果是mp4（type = 1/2/3），则播放视频。如果是mp3（type = 4），则播放音频。如果是图片(type = 5)，显示轮播。如果是文件(type = 4,6)，则显示文件，可以打开
									switch(type) {
										case 1:
										case 2:
										case 3:
											that.page.find('#lstvPlayer').html('<video id="video" src="' +
												baseurl + kjarr.url +
												'" controls="controls" webkit-playsinline="true' +
												'" style="width:100%;" preload="auto"></video>');
											break;
										case 4:
											that.page.find('#lstvPlayer').html('<audio id="audio" src="' +
												baseurl + kjarr.url + '" controls="controls"  style="width:100%;"></audio>');
											break;
										case 5:
											var picHtml = [];
											picHtml.push('<div class="swiper-container" style="padding-bottom:0"><div class="swiper-wrapper" id="slider"  style="height:180px">');
											var kjarrJson = JSON.parse(kjarr.url);
											var totalPic = kjarrJson.length;
											for(var i = 0; i < totalPic; i++) {
												var src = kjarrJson[i].picPath;
												picHtml.push('<div class="swiper-slide"><img style="height:100%" src="' + baseurl + src + '"></div>');
											}
											picHtml.push('</div></div>');
											that.page.find('#lstvPlayer').html(picHtml.join(''));
											//轮播效果
											$(".swiper-container").swiper(that.config);
											break;
										case 6:
											var wordhtml = [];
											wordhtml.push('<div  id="openFileDiv"  title = "' + baseurl + kjarr.url + '">')
											wordhtml.push('<img src="../../img/pdf.jpg">')
											wordhtml.push('<div class="openFileProcessBar"><div class="activeBar"></div></div></div>');
											wordhtml.push('<div class="downloadSuccess"><span class="icon icon-check"></span><span>已下载</span></div></div>')
											that.page.find('#lstvPlayer').html(wordhtml.join(''));
											that.openFiles();
											break;
										case 7:
											var wordhtml = [];
											wordhtml.push('<div  id="openFileDiv"  title = "' + baseurl + kjarr.url + '">')
											wordhtml.push('<img src="../../img/word.jpg">')
											wordhtml.push('<div class="openFileProcessBar"><div class="activeBar"></div></div></div>');
											wordhtml.push('<div class="downloadSuccess"><span class="icon icon-check"></span><span>已下载</span></div></div>')
											that.page.find('#lstvPlayer').html(wordhtml.join(''));
											that.openFiles();
											break;
										case 8:
											var wordhtml = [];
											wordhtml.push('<div  id="openFileDiv"  title = "' + baseurl + kjarr.url + '">')
											wordhtml.push('<img src="../../img/excel.jpg">')
											wordhtml.push('<div class="openFileProcessBar"><div class="activeBar"></div></div></div>');
											wordhtml.push('<div class="downloadSuccess"><span class="icon icon-check"></span><span>已下载</span></div></div>')
											that.page.find('#lstvPlayer').html(wordhtml.join(''));
											that.openFiles();
											break;

									}

								} else {
									slhtml.push('<li>');
								}

								slhtml.push('<a href="learn.html?kjid=' + kjarr.coursewareId +
									'&&uuid=' + kcuuid + '&&timeLength=' + logs.section[log].kejian[kj].timeLength + '" class="item-content row no-gutter">');
								slhtml.push('<span  class="col-70">' + (log + 1) + '.' + (kj + 1) + ' ' + logs.section[log].kejian[kj].name + '</span>');
								var progress;
								if(res.data.progres) {
									progress = JSON.parse(res.data.progres)[kjarr.coursewareId];
								} else {
									progress = 0;
								}

								slhtml.push('<span class="col-30">进度' + progress + '%</span>');

								slhtml.push('</a>');
								slhtml.push('</li>');
							}
							slhtml.push('</li>');
						}
					}
				} else {
					slhtml.push('<div class="nomsg">还没有目录</div>')
				}

				that.studylist.html(slhtml.join(''));

				that.progres();
			}

		});

		//课程评论列表
		common.get('/getAllAppraise.html', {
			userid: locuserid,
			uuid: kcuuid
		}, function(res) {
			var data = res.data;

			if(data.length > 0) {
				for(var com = 0; com < data.length; com++) {
					var data_item = data[com];
					comhtml.push('<li class="item-content">');
					comhtml.push('<div class="item-media"><img src="' + data_item.icon + '" alt=""></div>');
					comhtml.push('<div class="item-inner">');
					comhtml.push('<div class="item-title">' + data_item.nickName + '<span class="timer">' + data_item.dateApp + '</span></div>');
					comhtml.push('<div class="item-text">' + data_item.content + '</div>');

					if(data_item.interpretation) {
						comhtml.push('<div class="reply">');
						comhtml.push('<div class="item-title">' + data_item.userName + '<span class="timer">' + data_item.dateApp + '</span></div>');
						comhtml.push('<div class="item-text">' + data_item.interpretation + '</div>');
						comhtml.push('</div>');
					}

					comhtml.push('</div>');
					comhtml.push('<div class="clearfix"></div>');
					comhtml.push('</li>');
				}
			} else {
				comhtml.push('<div class="nomsg">还没有人评论过</div>');
			}

			that.commentlist.html(comhtml.join(''));

		});

		//测试
		common.get('/getCourseInfo.html', {
			userid: locuserid,
			uuid: kcuuid
		}, function(res) {
			var item = res.bean;

			if(item.kaoshiJson) {
				common.post('/getCourseExamInfo.html', {
					uuid: kcuuid,
					userid: locuserid
				}, function(res) {
					var item = JSON.parse(res.ksControl.kaoshiJson);
					var kshtml = [];

					kshtml.push('<li class="item-content">');
					kshtml.push('<div class="item-title">' + item.examName + '</div>');
					kshtml.push('<div class="item-text row no-gutter">');
					kshtml.push('<div class="col-100">考试时长：' + item.totalTm + '分钟</div>');
					kshtml.push('<div class="col-50">总分：' + item.totalScore + '分</div>');
					kshtml.push('<div class="col-50 align-right">及格分：' + item.okrate + '分</div></div>');
					kshtml.push('<a href="test.html?uuid=' + res.uuid +
						'" class="button button-fill button-big start" id="btnTest">参加考试</a>');
					kshtml.push('</li>');

					common.post('/validateCourseExam.html', {
						uuid: kcuuid,
						userid: locuserid
					}, function(res) {
						that.testlist.html(kshtml.join(''));

						if(res.examOverType != 0) {
							$('#btnTest').attr('href', '#').html('已结束').addClass('disabled');
						}
					});

				});
			} else {
				that.testlist.html('<div class="nomsg">还没有测试</div>');
			}
		});

		//用户评论
		that.Comment();

	};

	//打开文档
	videolearn.prototype.openFiles = function() {
		var that = this,
			dtaskprocess = null,
			dtask = null;
		$("#openFileDiv").off('click').on('click', function() {
			var url = $(this).prop('title');
			var urls = url.split("/");
			var filename = urls[urls.length - 1];
			//先判断文件是否已经下载
			plus.io.resolveLocalFileSystemURL("_downloads/" + filename, function(entry) {
				that.directOpenFiles(filename);
			}, function(e) {
				//判断是否正在下载当中
				if(dtaskprocess) {
					return;
				}
				var options = {
					method: "GET",
					filename: "_downloads/" + filename
				};
				dtask = plus.downloader.createDownload(url, options);
				dtask.addEventListener("statechanged", function(task, status) {
					if(!dtask) {
						return;
					}
					switch(task.state) {
						case 1: // 开始
							break;
						case 2: // 已连接到服务器
							break;
						case 3: // 已接收到数据
							//表示正在下载中
							dtaskprocess = 1;
							$(".openFileProcessBar").show();
							var downloadPercent = parseInt((task.downloadedSize / task.totalSize) * 100) + "%";
							$(".activeBar").css('width', downloadPercent);
							break;
						case 4: // 下载完成	
							dtaskprocess = null
							dtask = null;
							$(".openFileProcessBar").hide();
							$(".downloadSuccess").show();
							that.directOpenFiles(filename);
							break;
					}
				});
				dtask.start();
			});

		})
	}
	//直接打开文件
	videolearn.prototype.directOpenFiles = function(filename) {
		var that = this;
		plus.io.resolveLocalFileSystemURL("_downloads/" + filename, function(entry) {
			plus.runtime.openFile(entry.toURL(), {}, function(e) {
				plus.nativeUI.alert("无法打开此文件：" + e.emssage);
			});
		}, function(e) {});
		var data = {};
		var oli = that.studylist.find('li.active');
		data.uuid = kcuuid;
		data.userid = locuserid;
		data.kjid = kjid;
		data.progres = 100;
		common.post('/updateProgres.html', data, function(res) {
			if(res.error == 0) {
				//$.toast('课件进度已更新');
				$(oli).find('.col-30').html('进度' + 100 + '%');
			}
		});
	}

	//进度
	videolearn.prototype.progres = function() {
		var that = this;
		that.progre = 0;

		if(that.page.find('#video').length > 0) {
			var per = 0;
			var playVideo = document.getElementById('video');
			var oli = that.studylist.find('li.active');
			var fpro = $(oli).find('.col-30').html().split('进度')[1].split('%')[0];

			var duration;
			var cur = parseInt(fpro) / 100 * timeLength * 60;
			playVideo.currentTime = cur;
			//			playVideo.addEventListener("canplay",function(){
			//				playVideo.currentTime = cur;
			//			})

			playVideo.addEventListener("timeupdate", function() {

				var csec = playVideo.currentTime;

				duration = playVideo.duration;
				per = parseInt(csec / duration * 100);
				//根据当前播放的时间跟我们json的时间进行比较
				if(csec == 0) {
					per = 0;
					$(oli).find('.col-30').html('进度' + per + '%');
				} else {
					per = parseInt(csec / duration * 100);
					console.log(per);
					$(oli).find('.col-30').html('进度' + per + '%');

				}
			}, true);

			var data = {};
			var progressdata = {};

			that.progre = 100;
			this.loop = false;
			playVideo.onpause = function() {
				data.uuid = kcuuid;
				data.userid = locuserid;
				data.kjid = kjid;
				data.progres = per;
				common.post('/updateProgres.html', data, function(res) {
					if(res.error == 0) {
						//$.toast('课件进度已更新');
					}
				});
			};

			playVideo.onended = function() {
				data.uuid = kcuuid;
				data.userid = locuserid;
				data.kjid = kjid;
				data.progres = 100;
				common.post('/updateProgres.html', data, function(res) {
					if(res.error == 0) {
						//$.toast('课件进度已更新');
					}
				});
			};
			that.btnback.off('click').on('click', function() {
				data.uuid = kcuuid;
				data.userid = locuserid;
				data.kjid = kjid;
				data.progres = per;
				common.post('/updateProgres.html', data, function(res) {
					if(res.error == 0) {
						//$.toast('课件进度已更新');
					}
				});
				setTimeout(function() {
					$.router.load('item.html?uuid=' + kcuuid);
				}, 1000);

			})

		}

		if(that.page.find('#audio').length > 0) {
			var per;
			var playAudio = document.getElementById('audio');
			var oli = that.studylist.find('li.active');
			var fpro = $(oli).find('.col-30').html().split('进度')[1].split('%')[0];
			var duration;
			var cur = parseInt(fpro) / 100 * timeLength * 60;
			//安卓打包
			playAudio.currentTime = cur;
			//iOS打包
			//		    playAudio.addEventListener("canplay",function(){
			//				playAudio.currentTime = cur;
			//			})
			playAudio.addEventListener("timeupdate", function() {

				var csec = playAudio.currentTime;
				duration = playAudio.duration;
				per = parseInt(csec / duration * 100);
				//根据当前播放的时间跟我们json的时间进行比较
				if(csec == 0) {
					per = 0;
					$(oli).find('.col-30').html('进度' + per + '%');
				} else {
					per = parseInt(csec / duration * 100);
					$(oli).find('.col-30').html('进度' + per + '%');

				}
			}, true);

			var data = {};
			var progressdata = {};

			that.progre = 100;
			this.loop = false;
			playAudio.onpause = function() {
				data.uuid = kcuuid;
				data.userid = locuserid;
				data.kjid = kjid;
				data.progres = per;
				common.post('/updateProgres.html', data, function(res) {
					if(res.error == 0) {
						//$.toast('课件进度已更新');
					}
				});
			};

			playAudio.onended = function() {
				data.uuid = kcuuid;
				data.userid = locuserid;
				data.kjid = kjid;
				data.progres = 100;
				common.post('/updateProgres.html', data, function(res) {
					if(res.error == 0) {
						//$.toast('课件进度已更新');
					}
				});
			};

			that.btnback.off('click').on('click', function() {
				data.uuid = kcuuid;
				data.userid = locuserid;
				data.kjid = kjid;
				data.progres = per;
				common.post('/updateProgres.html', data, function(res) {
					if(res.error == 0) {
						//$.toast('课件进度已更新');
					}
				});
				setTimeout(function() {
					$.router.load('item.html?uuid=' + kcuuid);
				}, 1000);
			})

		} else if(that.page.find('#video').length == 0 && that.page.find('#audio').length == 0) {
			that.btnback.off('click').on('click', function() {
				$.router.load('item.html?uuid=' + kcuuid);
			})

		}
	};

	//用户评论
	videolearn.prototype.Comment = function() {
		var that = this;

		$(document).on('click', '#btnComment', function() {
			var popupHTML = '<div class="popup comment">' +
				'<header class="bar bar-nav">' +
				'<a class="icon icon-left pull-left close-popup"></a>' +
				'<h1 class="title">发表评论</h1>' +
				'<a class="pull-right" id="btnComSub">发布</a>' +
				'</header>' +

				'<div class="content bgwirte">' +
				'<div class="row no-gutter" id="apprlist">' +
				'<div class="col-30">不错哦</div>' +
				'<div class="col-30">一般般</div>' +
				'<div class="col-30">没意思</div>' +
				'</div>' +
				'<textarea id="usercom" class="usercom" maxlength="100" placeholder="在这里写评论"></textarea>' +
				'<p class="tipfont">100字内</p>' +
				'</div>';

			$.popup(popupHTML);

			$('#apprlist .col-30').off('click').on('click', function() {
				$('#apprlist .col-30').removeClass('active');
				$(this).addClass('active');
			});

			$('#btnComSub').off('click').on('click', function() {
				if($('#usercom').val() != "") {
					if($('#apprlist .active').length) {
						var appraise = 1;
					} else {
						var appraise = 0;
					}

					if(appraise) {
						console.log("appraise" + appraise)
						var data = {
							userid: locuserid,
							courseId: that.courseId,
							appraise: appraise,
							content: $('#usercom').val()
						};
						console.log(that);
						common.post('/courPingjia.html', data, function(res) {
							if(res > 0) {
								that.PageLoad();
								$.toast('发布成功');
								$.closeModal('.comment');
							} else {
								$.toast('发布失败');
							}
						});
					} else {
						alert(1)
						$.toast('请选择一种评价');
					}
				} else {
					$.toast('评论内容不能为空');
				}
			});
		});
	};

	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.data('page');

		if(!obj) {
			obj = new videolearn(e, id, $page);
		} else {
			$page.data('page', obj);
		}

		return obj;
	};
});