/**
 * Created by X01 on 2016-06-12.
 */
define(function(require, exports) {

	//公用类
	var common = require('common');
	//菜单
	/*var menu = require('menu');*/
	//左边菜单
	var leftmenu = require('leftmenu');
	var version;
	//获取用户id
	var locuserid = localStorage.getItem('userid');
	
	var myclass = function(e, id, page) {
		var that = this;

		//页面
		this.page = page;

		//列表
		this.myclasslist = page.find('#myclasslist');

		//筛选按钮
		this.screen = page.find('#screen');
		
		//the_menu显隐
		var my_courselist= localStorage.getItem('my_courselist');
		if(my_courselist=="true"){
			$("a[data-panel='#panel-left']").hide()
		}else{
			$("a[data-panel='#panel-left']").show();
			$("#back_my").hide();
		}
		
		//侧滑栏
		var $selected_on = $(".slide-menu-width .selected_on");
		var $selected_under = $(".slide-menu-width .selected_under");
		var $list_show = $(".slide-menu-width .list_show");
		var $list2_show = $(".slide-menu-width .list2_show");
		var $list3_show = $(".slide-menu-width .list3_show");
		var listDate = [];
		var statusdata = [{
			"id": 1,
			"text": "公共课",
			"insUserId": 0
		}, {
			"id": 2,
			"text": "开始的课程",
			"insUserId": 0
		}, {
			"id": 3,
			"text": "未开始的课程",
			"insUserId": 0
		}, {
			"id": 4,
			"text": "结束的课程",
			"insUserId": 0
		}]
		var baseurl = localStorage.getItem("base")

		$.ajax({
			type: "get",
			url: baseurl + '/mobileMta/getAllCourseClassify.html',
			async: true,
			success: function(data) {

				if(Array.isArray(data)) {
					listDate = data
				} else if(typeof(data) == 'string') {
					listDate = JSON.parse(data)
				}
				$list_show.append($(executeDate(listDate)));
				$list2_show.append($(executeDate(statusdata)));
			}
		});
		$(".slide-menu-width .selected").on('touchmove', function(e) {
			e.stopPropagation();
		});

		function executeDate(data) {
			//console.log(data);
			if(!data || !data.length || !Array.isArray(data)) {
				return;
			}
			var ul = document.createElement('ul');
			for(var i = 0; i < data.length; i++) {
				if(data[i].children) {
					//executeDate(data[i]);
				}
				ul.appendChild(createLi(data[i]));
			}
			return ul;
		}

		function createLi(obj) {
			var li = document.createElement('li');
			li.innerHTML = obj.text;
			li.id = obj.id;
			li.insUserId = obj.insUserId;
			if(obj.children) {
				li._children = obj.children;
			}
			return li;
		}

		//课程类型
		$list_show.on('click', 'li', function() {
			console.log($(this)[0]._children);
			$list_show.empty();
			$selected_on.append('<i>></i><span class="bread" data-id="' + $(this)[0].id + '">' + $(this).html() + '</span>');
			$list_show.append($(executeDate($(this)[0]._children)))
		})

		//课程状态
		$list2_show.on('click', 'li', function() {
			console.log($(this)[0]._children);
			$list2_show.empty();
			$selected_under.append('<i>></i><span class="bread" data-id="' + $(this)[0].id + '">' + $(this).html() + '</span>');
		})

		var findArr = [];

		//顶部面包屑上部点击事件
		$selected_on.on('click', 'span', function() {
			if($(this).text() == "课程类型：") {
				return;
			}
			$list_show.empty();
			if($(this).attr('data-id') == 0) {
				$list_show.append($(executeDate(listDate)));
			} else {
				console.log(findChild(listDate, $(this).attr('data-id')));
				console.log(findArr);
				$list_show.append($(executeDate(findArr)));
			}
			$(this).nextAll('.bread').remove();
			$(this).nextAll('i').remove();

		})

		//顶部面包屑下部点击事件
		$selected_under.on('click', 'span', function() {
			if($(this).text() == "课程状态：") {
				return;
			}
			$list2_show.empty();
			if($(this).attr('data-id') == 0) {
				$list2_show.append($(executeDate(statusdata)));
			}
			$(this).nextAll('.bread').remove();
			$(this).nextAll('i').remove();

		})		
		
		//排序点击事件
		$(".list3_show li").on("click",function(){
			$(".list3_show").find(".ischoose").removeClass("ischoose");
			$(this).addClass("ischoose")
		})
		
		function findChild(arr, id) {
			for(var i = 0; i < arr.length; i++) {
				if(arr[i].id == id) {
					findArr = arr[i].children;
					return arr[i];
				} else {
					if(arr[i].children) {
						findChild(arr[i].children, id);
					}
				}
			}
		}

		$(".in_left").on("click", "li", function() {
			$(".course_item_active").removeClass("course_item_active")
			$(this).addClass("course_item_active")
			if(this.id == "coursetype") {
				$list2_show.hide();
				$list3_show.hide();
				$list_show.show();
			} else if(this.id == "coursestatus") {
				$list3_show.hide();
				$list_show.hide();
				$list2_show.show();
			} else if(this.id == "paixu") {
				$list_show.hide();
				$list2_show.hide();
				$list3_show.show();

			}
		})

		$(document).on("click", '.icon-menu', function() {
			$.openPanel("#panel-screen");
		});

		$('#scrlist li').off('click').on('click', function() {
			var _index = $(this).index();
			$('#scrlist li').removeClass('active');
			$(this).addClass('active');
			$('#btnscr').attr('sid', _index);
		});

		//重置按钮点击事件
		$('#btnreset').off('click').on('click', function() {
			$list_show.empty();
			$list2_show.empty();
			$list_show.append($(executeDate(listDate)));
			$list2_show.append($(executeDate(statusdata)));
			$('.alltype').nextAll('.bread').remove();
			$('.alltype').nextAll('i').remove();
			$('.allstatus').nextAll('.bread').remove();
			$('.allstatus').nextAll('i').remove();
		})
		//确定按钮点击事件		
		var scrdata = {
			userid: locuserid
		};
		var coursetype;
		var coursestatus;
		var paixu;
		$('#btnscr').off('click').on('click', function() {
			coursetype = $selected_on.children("span:last-child").attr("data-id");
			coursestatus = $selected_under.children("span:last-child").attr("data-id");
			paixu = $(".list3_show .ischoose").attr("data-id")
			console.log(paixu)
			//			if(version) {
			//				scrdata = {
			//					userid: locuserid,
			//					kcClassifyId: coursetype,
			//					kcStatusId: coursestatus,
			//					orderFlg:"zx"
			//				}
			//			} else {
			//				scrdata = {
			//					userid: locuserid,
			//					kcStatusId: coursestatus,
			//					orderFlg:"zx"
			//				}
			//			};

			scrdata = {
				userid: locuserid,
				kcClassifyId: coursetype,
				kcStatusId: coursestatus,
				orderFlg: paixu
			}
			that.pageLoad(scrdata);
			$.closePanel('#panel-screen');

			//			var _index = $(this).attr('sid');		
			//          console.log(_index);
			//			switch(_index) {
			//				case '0':
			//					scrdata = {
			//						userid: locuserid
			//					};
			//					//页面加载
			//					that.pageLoad(scrdata);
			//					$.closePanel('#panel-screen');
			//					break;
			//				case '1':
			//					scrdata = {
			//						userid: locuserid,
			//						kcStatusId: 1
			//					};
			//					//页面加载
			//					that.pageLoad(scrdata);
			//					$.closePanel('#panel-screen');
			//					break;
			//				case '2':
			//					scrdata = {
			//						userid: locuserid,
			//						kcStatusId: 2
			//					};
			//					//页面加载
			//					that.pageLoad(scrdata);
			//					$.closePanel('#panel-screen');
			//					break;
			//				case '3':
			//					scrdata = {
			//						userid: locuserid,
			//						kcStatusId: 3
			//					};
			//					//页面加载
			//					that.pageLoad(scrdata);
			//					$.closePanel('#panel-screen');
			//					break;
			//				case '4':
			//					scrdata = {
			//						userid: locuserid,
			//						kcStatusId: 4
			//					};
			//					//页面加载
			//					that.pageLoad(scrdata);
			//					$.closePanel('#panel-screen');
			//					break;
			//			}
		});

		//页面加载
		this.pageLoad(scrdata);

		//菜单
		leftmenu.showmenu(this.page);

	};

	//页面加载
	myclass.prototype.pageLoad = function(scrdata) {
		var that = this;
		var baseurl = localStorage.getItem('base');
		/*       var baseurl = "localhost:8080/mobileMta";  */
		//轮播效果
		//$(".swiper-container").swiper(that.config);
		common.get('/CourseStudy.html', scrdata, function(res) {
			var html = [];

			if(res.total == 0) {
				html.push('<div class="nomsg">还没有我的课程</div>')
			} else {
				for(var i = 0; i < res.total; i++) {
					var item = res.rows[i];

					html.push('<li class="bgwirte">');
					html.push('<a href="item.html?uuid=' + item.uuid + '" class="item-content">');
					html.push('<div class="item-media" style="width: 107px;height: 60px">');
					if(item.pic) {
						html.push('<img src="' + baseurl + '/' + item.pic + '" alt="" />');
					} else {
						html.push('<img src="../../img/videoitem.jpg" alt="">');
					}
					html.push('</div>');
					html.push('<div class="item-inner">');

					/* if (item.beginTime == item.endTime) {
					     html.push('<div class="item-subtitle icon-time cutoff">' +
					         item.beginTime + '</div>');
					 } else {
					     html.push('<div class="item-subtitle icon-time cutoff">' +
					         item.beginTime + ' ~ ' + item.endTime + '</div>');
					 }*/

					html.push('<div class="item-text">');
					/* html.push('<div class="icon-user cutoff">' + item.lecturerName + '</div>');

					 html.push('<div class="icon-status cutoff">' + item.className + '</div>');*/
					html.push('课程名称：' + item.name + '');
					html.push('</div>');
					html.push('</div>');
					/* html.push('<div class="item-textarea cutoff">课程名称：' + item.name + '</div>');*/
					html.push('</a>');

					//                  if (item.publicClass == false) {
					//                      html.push('<div class="status">公开课</div>');
					//                  }

					html.push('</li>');
				}
			}

			that.myclasslist.html(html.join(''));
		});
	};

	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.data('page');

		if(!obj) {
			obj = new myclass(e, id, $page);
		} else {
			$page.data('page', obj);
		}
		return obj;
	};
});