/**
 * Created by X01 on 2016-06-14.
 */
define(function(require, exports) {
	//公用类
	var common = require('common');

	//获取用户ID
	var locuid = localStorage.getItem('userid');
	//获取UUID
	var uuid = location.href.split('=')[1];

	var test = function(e, id, page) {
		var that = this;
		that.page = page; //页面

		//回退按钮
		that.btnback = page.find('#btnback');

		//考试信息
		that.subinfo = page.find('#subinfo');
		//计时器
		that.coster = page.find('#coster');

		//题目列表
		that.analysisList = page.find('#analysisList');
		//题目
		that.Exercise = that.analysisList.find('.exercise');
		//标记(答案)按钮
		that.btnsign = page.find('#btnsign');
		//上一题按钮
		that.btnprev = page.find('#btnprev');
		//下一题按钮
		that.btnnext = page.find('#btnnext');

		//标记(答案)计数label
		that.sign = page.find('.sign');
		//答案查看次数
		that.signed = page.find('#signed');
		//已答题数
		that.answered = page.find('#answered');
		//未答题数
		that.noanswer = page.find('#noanswer');
		//已经做过的题数
		that.seen = page.find('#seen');
		//总题数
		that.matter = page.find('#matter');

		that.PageLoad();

	};

	//页面加载
	test.prototype.PageLoad = function() {
		var html = [];
		var that = this;
		that.btnback.off('click').on('click', function() {
			$.router.load('item.html?uuid=' + uuid);
		});

		common.post('/getCourseExamInfo.html', {
			uuid: uuid,
			userid: locuid
		}, function(res) {

			console.log(res)
			//考试信息
			that.subinfo.find('#subtitle').html('考试名称：' + JSON.parse(res.ksControl.kaoshiJson).examName).attr({
				sjid: res.sjId,
				kcid: res.id,
				courseid: res.courseId,
				okrate: JSON.parse(res.ksControl.kaoshiJson).okrate,
				credit: res.credit,
				certJson: res.certJson,
				passCondition: res.passCondition
			});

			//计时
			that.wait = res.time;
			//总时长
			that.total = JSON.parse(res.ksControl.kaoshiJson).totalTm;
			//及格分
			that.okrate = JSON.parse(res.ksControl.kaoshiJson).okrate;
			//总分
			that.allrate = JSON.parse(res.ksControl.kaoshiJson).totalScore;

			//考试时间到，强制交卷
			that.timecomtent();

			//考试固定题目列表
			var analysislist = JSON.parse(res.sjData.dShitimix).data;
			var thetitle;
			if(analysislist) {
				for(var a in analysislist) {
					var item = analysislist[a];
					if(item.title.indexOf("video") > -1) {
						thetitle = item.title.replace('"/upload/video/', '"http://dute.dutpbook.com/upload/video/');
						thetitle = thetitle.replace('"/upload/video/', '"http://dute.dutpbook.com/upload/video/');
						item.title = thetitle
					}

					if(item.shititypeid < 4) {
						if(res.dnandata != '') {
							var dnandata = JSON.parse(res.dnandata);
							if(dnandata[a - 1]) {
								var ksdefen = dnandata[a - 1].defen;
								var ksdaan = dnandata[a - 1].ksdaan;
							}

							if(ksdaan != '') {
								html.push('<li class="exercise bgwirte nomargin" label="' + a +
									'" sid="' + item.qsnid + '" fen="' + item.fen +
									'" daan="' + item.daan + '" defen="' + ksdefen + '" ua="' + ksdaan +
									'" visited="true" status="1" type="ds">');
							} else {
								html.push('<li class="exercise bgwirte nomargin" label="' + a +
									'" sid="' + item.qsnid + '" fen="' + item.fen +
									'" daan="' + item.daan + '" defen="' + ksdefen + '" ua="' + ksdaan + '" type="ds">');
							}
						} else {
							html.push('<li class="exercise bgwirte nomargin" label="' + a +
								'" sid="' + item.qsnid + '" fen="' + item.fen +
								'" daan="' + item.daan + '" defen="0" ua="" type="ds">');
						}
						html.push('<div class="subject">');

						switch(item.shititypeid) {
							case 1:
								html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">单选</span>');
								break;
							case 2:
								html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">多选</span>');
								break;
							case 3:
								html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">判断</span>');
								break;
							default:
								html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">其他</span>');
						}

						html.push('<span>' + a + '.' + item.title + '</span></div>');
						html.push('<ul class="answer">');

						if(item.shititypeid == 3) {
							html.push('<li>对</li>');
							html.push('<li>错</li>');
						} else if(item.shititypeid == 4) {
							html.push('<div class="nomsg">移动端不应该有填空题</div>');
						} else if(item.shititypeid == 5) {
							html.push('<div class="nomsg">移动端不应该有简答题</div>');
						} else if(item.shititypeid == 6) {
							html.push('<div class="nomsg">移动端不应该有阅读理解题</div>');
						} else {
							//							console.log(item)
							var xxlist = JSON.parse(item.xx);

							for(var k in xxlist) {
								if(res.dnandata != '') {
									var dnandata = JSON.parse(res.dnandata);
									if(dnandata[a - 1]) {
										var ksdaan = dnandata[a - 1].ksdaan;
									}

									if(k == ksdaan) {
										html.push('<li class="active">' + xxlist[k].xx + '</li>');
									} else {
										html.push('<li>' + xxlist[k].xx + '</li>');
									}
								} else {
									html.push('<li>' + xxlist[k].xx + '</li>');
								}
							}
						}

						html.push('</ul>');
						html.push('</div>');
						html.push('</li>');
					}
				}
			}

			//考试随机题目列表
			var dXtmixlist = JSON.parse(res.sjData.dXtmix).data;
			if(dXtmixlist) {
				for(var b in dXtmixlist) {
					var dxdata = dXtmixlist[b].data;

					for(var d = 1; d < dxdata.length; d++) {
						var item = dxdata[d];

						if(item.shititypeid < 4) {
							if(res.rdaandata != 'null' && res.rdaandata != "") {
								var rdaandata = JSON.parse(res.rdaandata);
								var ksdefen = JSON.parse(rdaandata[d - 1]).defen;
								var ksdaan = JSON.parse(rdaandata[d - 1]).ksdaan;

								if(ksdaan != '') {
									html.push('<li class="exercise bgwirte nomargin" label="' + d +
										'" sid="' + item.qsnid + '" fen="' + dxdata.fen +
										'" daan="' + item.daan + '" defen="' + ksdefen + '" ua="' + ksdaan +
										'" visited="true" status="1" type="dx">');
								} else {
									html.push('<li class="exercise bgwirte nomargin" label="' + d +
										'" sid="' + item.qsnid + '" fen="' + item.fen +
										'" daan="' + item.daan + '" defen="' + ksdefen + '" ua="' + ksdaan + '" type="dx">');
								}
							} else {
								html.push('<li class="exercise bgwirte nomargin" label="' + d +
									'" sid="' + item.qsnid + '" fen="' + item.fen +
									'" daan="' + item.daan + '" defen="0" ua="" type="dx">');
							}

							html.push('<div class="subject">');

							switch(item.shititypeid) {
								case 1:
									html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">单选</span>');
									break;
								case 2:
									html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">多选</span>');
									break;
								case 3:
									html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">判断</span>');
									break;
								default:
									html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">其他</span>');
							}

							html.push('<span class="label">' + d + '</span>.<span>' + item.title + '</span></div>');
							html.push('<ul class="answer">');

							if(item.shititypeid == 3) {
								var dxlist = {
									1: '对',
									2: '错'
								};

								for(var dx in dxlist) {
									if(res.rdaandata != 'null' && res.rdaandata != "") {
										var rdaandata = JSON.parse(res.rdaandata);
										if(rdaandata[d - 1]) {
											var ksdaan = JSON.parse(rdaandata[d - 1]).ksdaan;
										}

										if(dx == ksdaan) {
											html.push('<li class="active">' + dxlist[dx] + '</li>');
										} else {
											html.push('<li>' + dxlist[dx] + '</li>');
										}
									} else {
										html.push('<li>' + dxlist[dx] + '</li>');
									}
								}
							} else if(item.shititypeid == 4) {
								html.push('<div class="nomsg">移动端不应该有填空题</div>');
							} else if(item.shititypeid == 5) {
								html.push('<div class="nomsg">移动端不应该有简答题</div>');
							} else if(item.shititypeid == 6) {
								html.push('<div class="nomsg">移动端不应该有阅读理解题</div>');
							} else {
								var dxlist = JSON.parse(item.xx);
								for(var dx in dxlist) {
									if(res.rdaandata != 'null' && res.rdaandata != "") {
										var rdaandata = JSON.parse(res.rdaandata);
										var ksdaan = JSON.parse(rdaandata[d - 1]).ksdaan;

										if(dx == ksdaan) {
											html.push('<li class="active">' + dxlist[dx].xx + '</li>');
										} else {
											html.push('<li>' + dxlist[dx].xx + '</li>');
										}
									} else {
										html.push('<li>' + dxlist[dx].xx + '</li>');
									}
								}
							}

							html.push('</ul>');
							html.push('</div>');

							html.push('</li>');
						}
					}
				}
			}
			that.analysisList.html(html.join(''));

			//未答和总题数
			var noan = 0;
			for(var x = 0; x < that.analysisList.find('.exercise').length; x++) {
				var qs = that.analysisList.find('.exercise')[x];
				if($(qs).attr('ua') != '') {
					noan++;
				}
			}
			that.answered.text(noan);
			that.noanswer.text(that.analysisList.find('.exercise').length - noan);
			that.matter.text(that.analysisList.find('.exercise').length);

			//第一题默认显示
			$(that.analysisList.find('.exercise')[0]).addClass('show');

			//试卷提交事件
			that.submitbtnClick();

			//标记按钮事件
			that.btnsignClick();
			//上一题按钮事件
			that.btnprevClick();
			//下一题按钮事件
			that.btnnextClick();
			//答案选择事件
			that.AnswerChoose();

			//答题卡展开事件
			that.landing();
		});
	};

	//成绩页面返回按钮

	//考试时间计时器
	test.prototype.timecomtent = function() {
		var that = this;

		if(that.wait <= 0) {
			that.subinfo.find('.import').html('0/' + that.total + '分钟');
			$.toast('交卷时间到');

			//获取用户ID
			var locuid = localStorage.getItem('userid');
			//获取考试UUID
			var ksuuid = location.href.split('?')[1].split('=')[1];

			var Exercise = that.analysisList.find('.exercise');
			//错题集合
			var stids = [];
			//考试成绩
			var score = 0;
			//客户课程ID
			var kcid = that.subinfo.find('#subtitle').attr('kcid');
			//课程ID
			var cid = that.subinfo.find('#subtitle').attr('courseid');
			//学分
			var credit = that.subinfo.find('#subtitle').attr('credit');
			//JSON
			var certJson = that.subinfo.find('#subtitle').attr('certJson');
			//及格分
			var okrate = that.subinfo.find('#subtitle').attr('okrate');
			//通过条件
			var passCondition = that.subinfo.find('#subtitle').attr('passCondition');
			//考生固定题答案集合
			var dnandata = [];
			//考生随机题答案集合
			var rdaandata = [];

			for(var e = 0; e < Exercise.length; e++) {
				var item = $(Exercise[e]);
				var dnanitem = {};

				dnanitem.sid = item.attr('sid');
				dnanitem.title = item.find('.title span').last().text();
				dnanitem.jiexi = '';
				dnanitem.ksdaan = item.attr('ua');
				dnanitem.daan = item.attr('daan');
				dnanitem.fen = item.attr('fen');
				//dnanitem.defen = item.attr('defen');
				dnanitem.tx = item.find('.title').attr('tx');

				if(item.attr('type') == 'ds') {
					dnandata.push(dnanitem);
				} else {
					rdaandata.push(dnanitem);
				}

				score = score + parseInt(dnanitem.defen);

				if(item.attr('status') == '1') {
					if(item.attr('daan') != item.attr('ua')) {
						stids.push(item.attr('sid'))
					}
				}
			}

			//回传数据集
			var data = {
				userid: locuid,
				id: kcid,
				passCondition: passCondition,
				oprateFlg: 1,
				credit: credit,
				cid: cid,
				certJson: certJson,
				okrate: okrate,
				gdStr: JSON.stringify(dnandata),
				sjStr: JSON.stringify(rdaandata)
			};

			common.post('/submitCourseExam.html', data, function(res) {
				if(res.status == 1) {
					$.toast('考试时间到');
					setTimeout(function() {
						$.router.load('item.html?uuid=' + uuid);
					}, 3000);
				} else {
					$.toast('交卷失败');
				}
			});

		} else {
			that.wait--;
			setTimeout(function() {
				that.timecomtent();
				that.subinfo.find('.import').html(Math.floor(that.wait / 60) + '/' + that.total + '分钟');
			}, 1000);
		}
	};

	//试卷提交事件
	test.prototype.submitbtnClick = function() {
		var that = this;

		//获取用户ID
		var locuid = localStorage.getItem('userid');
		//获取考试UUID
		var ksuuid = location.href.split('?')[1].split('=')[1];

		var Exercise = that.analysisList.find('.exercise');
		//错题集合
		var stids = [];
		//客户课程ID
		var kcid = that.subinfo.find('#subtitle').attr('kcid');
		//课程ID
		var cid = that.subinfo.find('#subtitle').attr('courseid');
		//学分
		var credit = that.subinfo.find('#subtitle').attr('credit');
		//JSON
		var certJson = that.subinfo.find('#subtitle').attr('certJson');
		//及格分
		var okrate = that.subinfo.find('#subtitle').attr('okrate');
		//通过条件
		var passCondition = that.subinfo.find('#subtitle').attr('passCondition');
		//考生固定题答案集合
		var dnandata = [];
		//考生随机题答案集合
		var rdaandata = [];

		//保存按钮事件
		$('#btnsave').off('click').on('click', function() {
			//考试成绩
			var score = 0;

			for(var e = 0; e < Exercise.length; e++) {
				var item = $(Exercise[e]);
				var dnanitem = {};

				dnanitem.sid = item.attr('sid');
				dnanitem.title = item.find('.title span').last().text();
				dnanitem.jiexi = '';
				dnanitem.ksdaan = item.attr('ua');
				dnanitem.daan = item.attr('daan');
				dnanitem.fen = item.attr('fen');
				dnanitem.defen = item.attr('defen');
				dnanitem.tx = item.find('.title').attr('tx');

				if(item.attr('type') == 'ds') {
					dnandata.push(dnanitem);
				} else {
					rdaandata.push(dnanitem);
				}
				//				console.log(dnanitem)
				score = score + parseInt(dnanitem.defen);

				if(item.attr('status') == '1') {
					if(item.attr('daan') != item.attr('ua')) {
						stids.push(item.attr('sid'))
					}
				}
			}
			console.log(score)
			//回传数据集
			var data = {
				userid: locuid,
				id: kcid,
				passCondition: passCondition,
				oprateFlg: 0,
				credit: credit,
				cid: cid,
				certJson: certJson,
				okrate: okrate,
				gdStr: JSON.stringify(dnandata),
				sjStr: JSON.stringify(rdaandata)
			};

			common.post('/submitCourseExam.html', data, function(res) {
				if(res.status == 1) {
					$.toast('保存成功');
				} else {
					$.toast('保存失败');
				}
			});
		});

		//交卷按钮事件
		$('#btnhandin').off('click').on('click', function() {
			//考试成绩
			var score = 0;
			for(var e = 0; e < Exercise.length; e++) {
				var item = $(Exercise[e]);
				var dnanitem = {};
				dnanitem.sid = item.attr('sid');
				dnanitem.title = item.find('.title span').last().text();
				dnanitem.jiexi = '';
				dnanitem.ksdaan = item.attr('ua');
				dnanitem.daan = item.attr('daan');
				dnanitem.fen = item.attr('fen');
				dnanitem.defen = item.attr('defen');
				dnanitem.tx = item.find('.title').attr('tx');

				if(item.attr('type') == 'ds') {
					dnandata.push(dnanitem);
				} else {
					rdaandata.push(dnanitem);
				}

				console.log(score)
				score = score + parseInt(dnanitem.defen);
				console.log(dnanitem.defen)
				if(item.attr('status') == '1') {
					if(item.attr('daan') != item.attr('ua')) {
						stids.push(item.attr('sid'))
					}
				}
			}

			//回传数据集
			var data = {
				userid: locuid,
				id: kcid,
				score: score,
				passCondition: passCondition,
				oprateFlg: 1,
				credit: credit,
				cid: cid,
				certJson: certJson,
				okrate: okrate,
				gdStr: JSON.stringify(dnandata),
				sjStr: JSON.stringify(rdaandata)
			};

			$.modal({
				extraClass: 'tipcard',
				title: '<div class="tipcard-title">温馨提示</div>',
				text: '<div class="tipcard-cotent">' +
					'<p>你已回答了' + that.answered.html() + '题(共' + that.matter.html() + '题),确定交卷?</p>' +
					'<div class="row">' +
					'<a class="button-big button-fill button col-50 cancel" id="tipbtncancel">继续答题</a>' +
					'<a class="button-big button-fill button col-50 start" id="tipbtnupdata">交卷</a>' +
					'</div>'
			});

			$('#tipbtncancel').off('click').on('click', function() {
				$.closeModal('.tipcard');
			});

			$('#tipbtnupdata').off('click').on('click', function() {
				common.post('/submitCourseExam.html', data, function(res) {
					if(res.status == 1) {
						$.closeModal('.tipcard');
						that.testscore(data.score);
						//						console.log(data)
					} else {
						$.toast('交卷失败');
					}
				});
			});
		});
	};

	//标记按钮事件
	test.prototype.btnsignClick = function() {
		var that = this;

		that.btnsign.off('click').on('click', function() {
			if(that.analysisList.find('.show').hasClass('sign')) {
				that.analysisList.find('.show').removeClass('sign');
			} else {
				that.analysisList.find('.show').addClass('sign');
			}

			that.signed.text(that.analysisList.find('.sign').length);
		});
	};

	//暂停正在播放的音视频
	function video_pause() {
		var videoarr = $("video");
		for(var i = 0; i < videoarr.length; i++) {
			videoarr[i].pause();
		}
	}

	//上一题按钮事件
	test.prototype.btnprevClick = function() {
		var that = this;
		var Exercise = that.page.find('.exercise');

		that.btnprev.off('click').on('click', function() {

			video_pause();
			var Label = that.analysisList.find('.show').attr('label');

			if(Label > 1) {
				that.btnnext.text('下一题');
				Exercise.removeClass('show');
				Exercise.eq(Label - 1).addClass('show');
				that.seen.text(Label - 1);
			} else {
				$.toast('已经是第一题了');
			}
		});
	};

	//下一题按钮事件
	test.prototype.btnnextClick = function() {
		var that = this;
		var Exercise = that.analysisList.find('.exercise');
		that.btnnext.off('click').on('click', function() {
			video_pause();
			var matter = parseInt(that.matter.text());

			var Label = that.analysisList.find('.show').attr('label');

			if(Label >= matter) {
				$.toast('已经是最后一题了');
				that.seen.text(Label);
			} else {
				Exercise.removeClass('show');
				Exercise.eq(Label).addClass('show');
				that.seen.text(parseInt(Label) + 1);
			}
		});
	};

	//答题选择
	test.prototype.AnswerChoose = function() {
		var that = this;
		var Exercise = that.analysisList.find('.exercise');
		var answers = Exercise.find('.answer li');

		answers.off('click').on('click', function() {
			var answered = parseInt(that.answered.text());
			var noanswer = parseInt(that.noanswer.text());
			var visited = that.analysisList.find('.show').attr('visited');
			var fen = that.analysisList.find('.show').attr('fen');
			var daan = that.analysisList.find('.show').attr('daan');
			var tx = that.analysisList.find('.show .title').attr('tx');
			var ua = [];

			switch(tx) {
				case '1':
					//单选
					$(this).parents('.answer').find('li').removeClass('active');
					$(this).addClass('active');

					that.analysisList.find('.show').attr({
						'status': '1',
						'ua': that.page.find('.show .active').index() + 1
					});

					if(visited != 'true') {
						if(that.analysisList.find('.show li').hasClass('active')) {
							answered++;
							noanswer--;
							that.answered.text(answered);
							that.noanswer.text(noanswer);

							that.analysisList.find('.show').attr('visited', 'true');
						}
					}
					break;
				case '2':
					//不定项
					if($(this).hasClass('active')) {
						$(this).removeClass('active');
					} else {
						$(this).addClass('active');
					}

					that.analysisList.find('.show').attr({
						'status': '1',
						'ua': that.page.find('.show .active').index() + 1
					});
					if(visited != 'true') {
						if(that.analysisList.find('.show li').hasClass('active')) {
							answered++;
							noanswer--;
							that.answered.text(answered);
							that.noanswer.text(noanswer);

							that.analysisList.find('.show').attr({
								'visited': 'true',
								'ua': $(this).index() + 1
							});
						}
					} else {

						var __ua = [];

						var actives = that.analysisList.find('.show .active');

						for(var an = 0; an < actives.length; an++) {
							var item = actives[an];
							__ua.push($(item).index() + 1);
						}

						that.analysisList.find('.show').attr('ua', __ua.join(','));
					}
					break;
				case '3':
					//判断
					$(this).parents('.answer').find('li').removeClass('active');
					$(this).addClass('active');

					that.analysisList.find('.show').attr({
						'status': '1',
						'ua': that.page.find('.show .active').index() + 1
					});

					if(visited != 'true') {
						if(that.analysisList.find('.show li').hasClass('active')) {
							answered++;
							noanswer--;
							that.answered.text(answered);
							that.noanswer.text(noanswer);

							that.analysisList.find('.show').attr('visited', 'true');
						}
					}
					break;
			}

			//得分
			if(daan == that.analysisList.find('.show').attr('ua')) {
				that.analysisList.find('.show').attr('defen', fen);
			} else {
				that.analysisList.find('.show').attr('defen', '0');
			}

		})
	};

	//考试成绩
	test.prototype.testscore = function(score) {
		var that = this;
		var testscore = [];

		testscore.push('<div class="popup testscore">');
		testscore.push('<header class="bar bar-nav">');
		testscore.push('<a href="' + localStorage.getItem("back_courselist") + '" class="icon icon-left pull-left close-popup" id="back_courselist"></a>');
		testscore.push('<h1 class="title">考试得分</h1>');
		testscore.push('</header>');
		testscore.push('<div class="content bgwirte">');

		testscore.push('<ul class="list-block media-list homelist">');
		testscore.push('<li>');
		testscore.push('<div class="item-content item-link">');
		testscore.push('<div class="item-inner">');

		testscore.push('<div class="item-title">' + that.subinfo.find('#subtitle').html() + '</div>');

		testscore.push('<div class="item-subtitle">');
		testscore.push('<span>满分：' + that.allrate + '分</span>');
		testscore.push('<span>及格分：' + that.okrate + '分</span>');
		testscore.push('</div>');

		testscore.push('<div class="row no-gutter">');
		if(that.okrate > score) {
			testscore.push('<div class="col-40 false">' + score + '分</div>');
		} else {
			testscore.push('<div class="col-40 true">' + score + '分</div>');
		}
		testscore.push('<div class="col-60">');
		//		testscore.push('<a href="../me/me.html" class="button button-big button-fill start">用户中心</a>');
		//		testscore.push('<a href="../score/list.html" class="button button-big button-fill">查看成绩</a>');
		testscore.push('</div>');
		testscore.push('</div>');

		testscore.push('</div>');
		testscore.push('</div>');
		testscore.push('</li>');
		testscore.push('</ul>');

		testscore.push('</div>');
		testscore.push('</div>');

		$.popup(testscore.join(''));
	};

	//答题卡展开事件
	test.prototype.landing = function() {
		var that = this;
		var Status, Sign;

		$(document).on('click', '#btnOpen', function() {
			var signed = that.signed.text();
			var answered = that.answered.text();
			var noanswer = that.noanswer.text();
			var seen = that.seen.text();
			var matter = that.matter.text();
			var Exercise = that.analysisList.find('.exercise');
			var html = [];

			html.push('<div class="popup answercard">');

			html.push('<div class="subinfo bgwirte">');
			html.push('<div class="row no-gutter">');

			html.push('<div class="col-25">');
			if(that.pageType == 'fms') {
				html.push('<span>答案</span>');
			} else {
				html.push('<span>标记</span>');
			}
			html.push('<span>' + signed + '</span>');
			html.push('</div>');

			html.push('<div class="col-25">');
			html.push('<span>已答</span>');
			html.push('<span>' + answered + '</span>');
			html.push('</div>');

			html.push('<div class="col-25">');
			html.push('<span>未答</span>');
			html.push('<span>' + noanswer + '</span>');
			html.push('</div>');

			html.push('<div class="col-25 close-popup">');
			html.push('<span class="icon icon-card"></span>');
			html.push('<span>' + seen + '</span>/<span>' + matter + '</span>');
			html.push('</div>');

			html.push('</div>');
			html.push('</div>');

			html.push('<div class="row no-gutter qcon">');
			for(var i = 1; i <= Exercise.length; i++) {
				Status = Exercise.eq(i - 1).attr('status');
				Sign = Exercise.eq(i - 1).hasClass('sign');

				if(Sign) {
					//已标记
					html.push('<div class="col-15 close-popup wrong">' + i + '</div>');
				} else if(Status == '1') {
					//已答
					html.push('<div class="col-15 close-popup right">' + i + '</div>');
				} else {
					html.push('<div class="col-15 close-popup">' + i + '</div>');
				}
			}
			html.push('</div>');

			html.push('</div>');

			var popupHTML = html.join('');

			$.popup(popupHTML);

			//点击题号跳到对应题目
			for(var s = 0; s <= Exercise.length; s++) {
				$('.qcon .col-15').eq(s).off('click').on('click', function() {
					Exercise.removeClass('show');
					Exercise.eq($(this).text() - 1).addClass('show');

					that.seen.text(that.analysisList.find('.show').attr('label'))
				})
			}
		});
	};

	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.attr('page');

		if(!obj) {
			obj = new test(e, id, $page);
		} else {
			$page.attr('page', obj);
		}
		return obj;
	};
});