define(function (require, exports) {

    //公用类
    var common = require('common');
    //菜单
    //var menu = require('menu');
    //左边菜单
    var leftmenu = require('leftmenu');
    //获取用户ID
    var locuid = localStorage.getItem('userid');

    var exerlist = function (e, id, page) {
        this.page = page;//页面

        this.veiwlist = page.find('#veiwlist')
        
        //侧栏菜单
        if (locuid == null) {
            this.page.find('.open-panel').on('click', function () {
                $.toast('更多功能在登录之后回来');
                setTimeout(function () {
                    $.router.load('../index.html');
                }, 3000);
            });
        } else {
          leftmenu.showmenu(this.page);
        }
        //页面加载
        this.PageLoad();

        //菜单
        //menu.showmenu(this.page, '3');
    };

    //页面加载
    exerlist.prototype.PageLoad = function () {
        var that = this;
        var html = [];

        //在线练习
        common.get('/findExerciseList.html', {page: 1, rows: 20, userid: locuid}, function (res) {
            var html = [];

            if (res.total == 0) {
                that.veiwlist.html('<div class="nomsg">还没有我的练习</div>');
            } else {
                for (var x = 0; x < res.total; x++) {
                    var item = res.rows[x];

                    html.push('<li class="bgwirte" sjid="' + item.sjid + '">');
                    html.push('<a href="test.html?uuid=' + item.uuid + '">');
                    html.push('<div class="item-content item-link">');
                    html.push('<div class="item-inner">');
                    html.push('<div class="item-title">练习名称：' + item.name + '</div>');
                    if (item.beginTm && item.endTm && item.beginTm == item.endTm) {
                        html.push('<div class="item-subtitle icon-time">' + item.beginTm + ' - ' + item.endTm + '</div>');
                    } else {
                        html.push('<div class="item-subtitle icon-time">随到随考</div>');
                    }
                    html.push('<div class="item-title-row">');
                    html.push('<div class="item-subtitle icon-class">总分：' + item.totalsorce + '</div>');
                    html.push('<div class="item-subtitle nomal">开始练习</div>');
                    html.push('</div>');
                    html.push('</div>');
                    html.push('</div>');
                    html.push('</a>');
                    html.push('</li>');
                }

                that.veiwlist.html(html.join(''));
            }
        });
    };

    //下拉加载
    exerlist.prototype.DorpDownLoad = function () {
        var that = this;
        // 加载flag
        var loading = false;
        // 最多可加载的条目
        var maxItems = 1000;

        // 每次加载添加多少条目
        var itemsPerLoad = 20;

        // 上次加载的序号
        var lastIndex = 20;

        function addItems(number, lastIndex) {
            common.get('/findExerciseList.html', {}, function (res) {
                var dorphtml = [];
                if (res.length == 0) {
                    that.veiwlist.html('<div class="nomsg">还没有在线测试</div>');
                } else {
                    // 生成新条目的HTML
                    for (var i = lastIndex + 1; i <= lastIndex + number; i++) {
                        var item = res.rows[i];

                        dorphtml.push('<li>');
                        dorphtml.push('<a href="item.html">');
                        dorphtml.push('<div class="item-content item-link">');
                        dorphtml.push('<div class="item-inner">');
                        dorphtml.push('<div class="item-title">考试名称</div>');
                        dorphtml.push('<div class="item-subtitle icon-time">2015.2.2 19:00 - 2015.3.6 19:00</div>');
                        dorphtml.push('<div class="item-title-row">');
                        dorphtml.push('<div class="item-subtitle icon-class">总分：500</div>');
                        dorphtml.push('<div class="item-subtitle free icon-status">参加考试</div>');
                        dorphtml.push('</div>');
                        dorphtml.push('</div>');
                        dorphtml.push('</div>');
                        dorphtml.push('</a>');
                        dorphtml.push('</li>');
                    }

                    // 添加新条目
                    that.veiwlist.append(dorphtml.join(''));

                    that.isfirst = false;
                }
            });
        }

        //预先加载20条
        addItems(itemsPerLoad, 0);

        // 注册'infinite'事件处理函数
        $(document).on('infinite', '.infinite-scroll', function () {

            // 如果正在加载，则退出
            if (loading) return;

            // 设置flag
            loading = true;

            // 模拟1s的加载过程
            setTimeout(function () {
                // 重置加载flag
                loading = false;

                if (lastIndex >= maxItems) {
                    // 加载完毕，则注销无限加载事件，以防不必要的加载
                    $.detachInfiniteScroll($('.infinite-scroll'));
                    // 删除加载提示符
                    $('.infinite-scroll-preloader').remove();
                    return;
                }

                // 添加新条目
                if (that.tab2.hasClass('active')) {
                    addItems(itemsPerLoad, lastIndex);
                }
                // 更新最后加载的序号
                lastIndex = that.veiwlist.find('li').length;
                //容器发生改变,如果是js滚动，需要刷新滚动
                $.refreshScroller();
            }, 1000);
        });
    };

    exports.init = function (e, id, page) {

        var $page = $(page);

        var obj = $page.data('page');

        if (!obj) {
            obj = new exerlist(e, id, $page);
        } else {
            $page.data('page', obj);
        }
        return obj;
    };
})
;