/**
 * Created by X01 on 2016-06-17.
 */
define(function (require, exports) {
    //公用类
    var common = require('common');

    //获取用户ID
    var locuid = localStorage.getItem('userid');

    var myexercise = function (e, id, page) {
        this.page = page;//页面

        //考试信息
        this.subinfo = page.find('#subinfo');

        //题目列表
        this.analysisList = page.find('#analysisList');
        //题目
        this.Exercise = this.analysisList.find('.exercise');
        //标记(答案)按钮
        this.btnsign = page.find('#btnsign');
        //上一题按钮
        this.btnprev = page.find('#btnprev');
        //下一题按钮
        this.btnnext = page.find('#btnnext');

        //标记(答案)计数label
        this.sign = page.find('.sign');
        //答案查看次数
        this.signed = page.find('#signed');
        //已答题数
        this.answered = page.find('#answered');
        //未答题数
        this.noanswer = page.find('#noanswer');
        //已经做过的题数
        this.seen = page.find('#seen');
        //总题数
        this.matter = page.find('#matter');

        //页面加载
        this.PageLoad();

    };

    //页面加载
    myexercise.prototype.PageLoad = function () {
        var that = this;
        var html = [];

        //获取考试ID
        var ksid = location.href.split('?')[1].split('&')[0].split('=')[1];
        //获取成绩ID
        var csid = location.href.split('?')[1].split('&')[1].split('=')[1];
        //获取及格分数
        var okrate = location.href.split('?')[1].split('&')[2].split('=')[1];
        //字符数组
        var arr = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];

        common.post('/resultInfo.html', {userid: locuid, ksid: ksid, id: csid}, function (res) {
            var html = [];
            var regex = new RegExp('（', 'g'); // 使用g表示整个字符串都要匹配
            console.log(res);
            //考试信息
            that.subinfo.find('#subtitle').html(res.kaoshiInfo.ksName).attr({
                ksid: res.kaoshiInfo.ksid,
                scid: res.shijuanInfo.id
            });

            if (parseInt(res.kaoshiInfo.sorce) < parseInt(okrate)) {
                that.subinfo.find('#scinfo').html('<span class="fail">得分: ' +
                    res.kaoshiInfo.sorce + '</span> / ' + res.kaoshiInfo.totalsorce);
            } else {
                that.subinfo.find('#scinfo').html('<span class="pass">得分: ' +
                    res.kaoshiInfo.sorce + '</span> / ' + res.kaoshiInfo.totalsorce);
            }

            //考试固定题目列表
            var analysislist = JSON.parse(res.shijuanInfo.dShitimix).data;
            console.log(analysislist);
            if(analysislist){
            	var num = 0;
                for (var sca  in analysislist) {
                    var item = analysislist[sca];
                   if (item.shititypeid) {
                     	num++;
                     	var ksdaan=JSON.parse(res.shijuanInfo.dnandata)[num - 1].ksdaan;
                     	var defen=JSON.parse(res.shijuanInfo.dnandata)[num - 1].defen;
                     	if(item.shititypeid=='6'){
                        	var children= JSON.parse(res.shijuanInfo.dnandata)[num -1].children;
                        	for(var n in children){
                        		if(children[n].ksdaan !=null&&children[n].ksdaan !=''){
                        			ksdaan="children_ua";
                        		}
                        	}
                        }
                    	if (typeof(ksdaan) !='undefined' && ksdaan != '') {
                       		html.push('<li class="exercise bgwirte nomargin" label="' + sca +
                            '" sid="' + item.qsnid + '" fen="' + item.fen +
                            '" daan="' + item.daan + '" ua=' + ksdaan +
                            ' status="1" type="ds">');
                        } else {
                            html.push('<li class="exercise bgwirte nomargin" label="' + sca +
                            '" sid="' + item.qsnid + '" fen="' + item.fen +
                            '" daan="' + item.daan + '" ua="" type="ds">');
                        }
                        html.push('<div class="subject">');
                        switch (item.shititypeid) {
                            case 1:
                                html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">单选</span>');
                                break;
                            case 2:
                                html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">不定项</span>');
                                break;
                            case 3:
                                html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">判断</span>');
                                break;
                            case 4:
                                html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">填空</span>');
                                break;
                            case 5:
                                html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">简答</span>');
                                break;
                            case 6:
                                html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">阅读理解</span>');
                                break;
                        }
                        var title = item.title;
						if(title.indexOf("<img") >= 0){
							if(title.indexOf("/upload/upload") >= 0){
								title = title.replace("/upload/upload",base + "/upload/upload");
							}else{
								title = title.replace("src='","src='" + base).replace('src="','src="' + base);
							}
						}
                        html.push('<span>' + sca + '.' + title + '</span></div>');
                        if(item.shititypeid<=3){
                        	html.push('<ul class="answer">');
                        	if (item.shititypeid == 3) {
	                            if (ksdaan == '0') {
	                                html.push('<li>对</li>');
	                                html.push('<li class="active">错</li>');
	                            } else if (ksdaan == '1') {
	                                html.push('<li class="active">对</li>');
	                                html.push('<li>错</li>');
	                            }else {
	                                html.push('<li>对</li>');
	                                html.push('<li>错</li>');
	                            }
	                        } else if (item.shititypeid == 2) {
	                        	var xxlist = JSON.parse(item.xx);
	                        	var daanarr=ksdaan.split(',');
                            	for (var sck in xxlist) {
	                                if ($.inArray(sck, daanarr) >= 0) {
	                                    html.push('<li class="active">' + xxlist[sck].xx + '</li>');
	                                } else {
	                                    html.push('<li>' + xxlist[sck].xx + '</li>');
	                                }
	                            }
	                        }else if (item.shititypeid == 1){//单选
	                        	var xxlist = JSON.parse(item.xx);
                            	for (var sck in xxlist) {
	                                if (sck==ksdaan) {
	                                    html.push('<li class="active">' + xxlist[sck].xx + '</li>');
	                                } else {
	                                    html.push('<li>' + xxlist[sck].xx + '</li>');
	                                }
	                            }
	                        }
                        }else if (item.shititypeid == 4) {
                            var n=item.title.match(regex).length;//()的个数
							var j;//答题区序号
                        	html.push('<div class="datiqu"><h6>答题区</h6><div class="datiqu-content">');
                        	if(ksdaan != ''){
                          		for(var i=0;i<n;i++){
                        			var j=i+1;
	                        		html.push('<div class="row"><div class="item-title col-10">('+ j +')</div><div class="item-input col-90"><input type="text" readonly placeholder="'+ ksdaan[j].kong +'" name="tk" / ></div></div>');	 
	                        	}
                        	}else{
                        		for(var i=0;i<n;i++){
                        			var j=i+1;
                        			html.push('<div class="row"><div class="item-title col-10">('+ j +')</div><div class="item-input col-90"><input type="text" readonly placeholder=" " name="tk" / ></div></div>');
                        		}
                        	}
                        	html.push('</div></div>');
                        } else if (item.shititypeid == 5) {
                            html.push('<div class="title2">'+ item.daan +'</div>'); 
                        	html.push('<div class="datiqu"><h6>答题区</h6><div class="datiqu-content">'); 
                            html.push('<div class="row"><div class="item-input col-100"><textarea ua="" fen="0" name="jd" readonly placeholder="'+ ksdaan +'" /></textarea></div></div>');
                        	html.push('</div></div>');
                        }
                        else if (item.shititypeid == 6) {
                        	html.push('<div class="question"><ul>');
                            var data=JSON.parse(item.data); 
                            var children=JSON.parse(res.shijuanInfo.dnandata)[num - 1].children;
                            for(var b in data){
                            	var ksda=children[b].ksdaan;
                            	html.push('<li class="ydlj">');
                            	if(data[b].tx=="jianda"){
                                	html.push('<div class="title" tx="' + data[b].tx + '"><span class="subtype">简答</span>');
                                	html.push('<span>(' + b + ').' + data[b].title + '</span></div>');
                                	html.push('<div class="datiqu"><h6>答题区</h6><div class="datiqu-content">'); 
                                	if(ksda){
                                		html.push('<div class="row"><div class="item-input col-100"><textarea ua="" fen="0" name="jd" readonly placeholder="'+ksda+'" /></textarea></div></div>');
                                	}else{
                                		html.push('<div class="row"><div class="item-input col-100"><textarea ua="" fen="0" name="jd" readonly placeholder="" /></textarea></div></div>');
                                	}
		                        	html.push('</div></div>');
                            	}
                            	else{
                            		var xxlist = data[b].xx;//四个选项
                            		var daanarr=[];
                            		if(ksda){
                            			daanarr = ksda.split(',');
                            		}
                            		switch (data[b].tx){
                            			case 'danxuan':
                            			html.push('<div class="title" tx="' + data[b].tx + '"><span class="subtype">单选</span>');
                            			break;
                            			case 'duoxuan':
                            			html.push('<div class="title" tx="' + data[b].tx + '"><span class="subtype">不定项</span>');
                            			break;
                            			case 'panduan':
                            			html.push('<div class="title" tx="' + data[b].tx + '"><span class="subtype">判断</span>');
                            			break;
                            			
                            		}
                            		html.push('<span>(' + b + ').' + data[b].title + '</span></div>');
                            		html.push('<ul class="answer">');
                            		if(data[b].tx=="danxuan"||data[b].tx =="duoxuan"){
	                            		for (var sck in xxlist) {
			                                if ($.inArray(sck, daanarr) >= 0) {
			                                    html.push('<li class="active">' + xxlist[sck].xx + '</li>');
			                                } else {
			                                    html.push('<li>' + xxlist[sck].xx + '</li>');
			                                }
			                            }
                              		}else if (data[b].tx =="panduan") {
                              			if(ksda){
                              				if (ksda=='0') {
			                                	html.push('<li>对</li>');
			                                	html.push('<li class="active">错</li>');
			                                } else if(ksda=='1'){
			                                	html.push('<li class="active">对</li>');
			                                	html.push('<li>错</li>');
			                                }else {
			                                    html.push('<li>对</li>');
			                                	html.push('<li>错</li>');
		                                	}
                              			}else{
                              				html.push('<li>对</li>');
		                                	html.push('<li>错</li>');
                              			}
                              			
                            		}
			                        html.push('</ul>');
                            	}
                            	html.push('</li>');
                            }
                            html.push('</ul></div>');
                        }
                        html.push('</ul>');
                        html.push('</div>');

                        html.push('<div class="analysis">');
                        html.push('<h1 class="title">本题得分:'+defen+'</h1>');
                        if(item.shititypeid < 3){
                        	html.push('<h1 class="title">正确答案：');
                            for (var zf = 0; zf < item.daan.split(',').length; zf++) {
                                html.push(arr[item.daan.split(',')[zf] - 1]);
                            }
                            html.push('</h1>');
                        }else if (item.shititypeid == 3) {
                            if (item.daan == '1') {
                                html.push('<h1 class="title">正确答案：对</h1>');
                            } else {
                                html.push('<h1 class="title">正确答案：错</h1>');
                            }
                        } else if(item.shititypeid == 4){
                            html.push('<h1 class="title">正确答案：</h1>');
                            var daan=JSON.parse(item.daan);
                            for (var a  in daan) {
                         		var zqda=daan[a].kong; 
                         		var reg=/#/g;
	                         		zqda=zqda.replace(reg,' ');
                         		 html.push('<div class="row"><div class="item-title col-10">('+ a +')</div><div class="item-input col-90"><input type="text" ua="" fen="0" name="tk" index='+ j +' placeholder="'+ zqda +'" /></div></div>');
                            }
                        }else if(item.shititypeid == 5){
                        	html.push('<h1 class="title">正确答案：</h1>');
                        	html.push('<div class="content">' + item.daan + '</div>');
                        }else if(item.shititypeid == 6){
                        	html.push('<h1 class="title">正确答案：</h1>');
                        	var zqda_arr=JSON.parse(item.data);
                        	console.log(zqda_arr);
                        	for(var a  in zqda_arr){
                        		var daan=' ';
                        		if(zqda_arr[a].tx=='danxuan'){
			                        daan=arr[zqda_arr[a].daan-1];
                        		}else if(zqda_arr[a].tx=='duoxuan'){
                        			for (var zf = 0; zf < zqda_arr[a].daan.split(',').length; zf++) {
                        				if(daan==" "){
                        					daan=arr[zqda_arr[a].daan.split(',')[zf]-1];
                        				}else{
                        					daan=daan+"、"+arr[zqda_arr[a].daan.split(',')[zf]-1];
                        				}
		                            }
                        		}else if(zqda_arr[a].tx=='panduan'){
                        			if (zqda_arr[a].daan == '1') {
		                                daan="对";
		                            } else {
		                                daan="错";
		                            }
                        		}else if(zqda_arr[a].tx=='jianda'){
                        			daan=zqda_arr[a].daan;
                        		}
                        		html.push('<div class="content">' );
                    			html.push('<div class="row"><div class="item-title col-10">('+ a +')</div><div class="item-input col-90">'+daan+'</div></div>');
                    			html.push('</div>');
                        	}
                        }
                        html.push('<h1 class="title">答案解析:</h1>');
                        html.push('<div class="content">' + item.jieda + '</div>');
                        html.push('</div>');                    
                        html.push('</li>');      
                       
                    } 
                    /*console.log(html.join(''));*/
                }
            
            }
            //考试随机题目列表
            var dXtmixlist = JSON.parse(res.shijuanInfo.dXtmix);
            console.log(JSON.parse(res.shijuanInfo.rdaandata));
            if (dXtmixlist) {

                var _index = -1;
                for (var b in dXtmixlist) {
                    var dxdata = dXtmixlist[b].data;

                    for (var d = 1; d <= dxdata.length; d++) {

                        _index++;

                        var item = dxdata[d-1];
                        var ksdaan=JSON.parse(res.shijuanInfo.rdaandata)[_index].ksdaan;
                     	var defen=JSON.parse(res.shijuanInfo.rdaandata)[_index].defen;
                        if (item.shititypeid) {
                        	if(item.shititypeid=='6'){
                              	var children= JSON.parse(res.shijuanInfo.rdaandata)[_index].children;
                            	for(var n in children){
                            		if(children[n].ksdaan !=null&&children[n].ksdaan !=''){
                            			ksdaan="children_ua";
                            		}
                            	}
                            }
                            if (typeof(ksdaan) !='undefined' && ksdaan != '') {
                        		html.push('<li class="exercise bgwirte nomargin" label="' + d +
                                '" sid="' + item.qsnid + '" fen="' + dXtmixlist[b].fen +
                                '" daan="' + item.daan + '" ua=' + ksdaan +
                                ' status="1" type="dx">');
                            } else {
                                html.push('<li class="exercise bgwirte nomargin" label="' + d +
                                    '" sid="' + item.qsnid + '" fen="' + dXtmixlist[b].fen +
                                    '" daan="' + item.daan + '" ua="" type="dx">');
                            }
                            html.push('<div class="subject">');

                            switch (item.shititypeid) {
                                case 1:
                                    html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">单选</span>');
                                    break;
                                case 2:
                                    html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">不定项</span>');
                                    break;
                                case 3:
                                    html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">判断</span>');
                                    break;
                                case 4:
	                                html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">填空</span>');
	                                break;
	                            case 5:
	                                html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">简答</span>');
	                                break;
	                            case 6:
	                                html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">阅读理解</span>');
	                                break;
                            }
                            var title = item.title;
							if(title.indexOf("<img") >= 0){
								if(title.indexOf("/upload/upload") >= 0){
									title = title.replace("/upload/upload",base + "/upload/upload");
								}else{
									title = title.replace("src='","src='" + base).replace('src="','src="' + base);
								}
							}
                            html.push('<span class="label">' + d + '</span>.<span>' + title + '</span></div>');
                            if(item.shititypeid<=3){
                            	html.push('<ul class="answer">');
	                        	if (item.shititypeid == 3) {
		                            if (ksdaan == '0') {
		                                html.push('<li>对</li>');
		                                html.push('<li class="active">错</li>');
		                            } else if (ksdaan == '1') {
		                                html.push('<li class="active">对</li>');
		                                html.push('<li>错</li>');
		                            }
		                            else {
		                                html.push('<li>对</li>');
		                                html.push('<li>错</li>');
		                            }
		                        } else if (item.shititypeid == 2) {
		                        	var xxlist = JSON.parse(item.xx);
		                        	var daanarr=ksdaan.split(',');
	                            	for (var sck in xxlist) {
		                                if ($.inArray(sck, daanarr) >= 0) {
		                                    html.push('<li class="active">' + xxlist[sck].xx + '</li>');
		                                } else {
		                                    html.push('<li>' + xxlist[sck].xx + '</li>');
		                                }
		                            }
		                        }else if (item.shititypeid == 1){//单选
		                        	var xxlist = JSON.parse(item.xx);
	                            	for (var sck in xxlist) {
		                                if (sck==ksdaan) {
		                                    html.push('<li class="active">' + xxlist[sck].xx + '</li>');
		                                } else {
		                                    html.push('<li>' + xxlist[sck].xx + '</li>');
		                                }
		                            }
		                        }
	                        }else if (item.shititypeid == 4) {
	                            var n=item.title.match(regex).length;//()的个数
								var j;//答题区序号
	                        	html.push('<div class="datiqu"><h6>答题区</h6><div class="datiqu-content">');
	                        	if(ksdaan != ''){
	                          		for(var i=0;i<n;i++){
	                        			j=i+1;
		                        		html.push('<div class="row"><div class="item-title col-10">('+ j +')</div><div class="item-input col-90"><input type="text" readonly placeholder="'+ ksdaan[j].kong +'" name="tk" / ></div></div>');	 
		                        	}
	                        	}else{
	                        		for(var i=0;i<n;i++){
	                        			j=i+1;
	                        			html.push('<div class="row"><div class="item-title col-10">('+ j +')</div><div class="item-input col-90"><input type="text" readonly placeholder=" " name="tk" / ></div></div>');
	                        		}
	                        	}
	                        	html.push('</div></div>');
                        	} else if (item.shititypeid == 5) {
	                            html.push('<div class="title2">'+ item.daan +'</div>'); 
	                        	html.push('<div class="datiqu"><h6>答题区</h6><div class="datiqu-content">'); 
	                            html.push('<div class="row"><div class="item-input col-100"><textarea ua="" fen="0" name="jd" readonly placeholder="'+ ksdaan +'" /></textarea></div></div>');
	                        	html.push('</div></div>');
                            } else if (item.shititypeid == 6) {
	                        	html.push('<div class="question"><ul>');
	                            var data=JSON.parse(item.data); 
	                            var children=JSON.parse(res.shijuanInfo.rdaandata)[_index].children;
	                            
	                            for(var a in data){
	                            	var ksda=children[a].ksdaan;
	                            	html.push('<li class="ydlj">');
	                            	if(data[a].tx=="jianda"){
	                                	html.push('<div class="title" tx="' + data[a].tx + '"><span class="subtype">简答</span>');
	                                	html.push('<span>(' + a + ').' + data[a].title + '</span></div>');
	                                	html.push('<div class="datiqu"><h6>答题区</h6><div class="datiqu-content">'); 
			                            if(ksda){
	                                		html.push('<div class="row"><div class="item-input col-100"><textarea ua="" fen="0" name="jd" readonly placeholder="'+ksda+'" /></textarea></div></div>');
	                                	}else{
	                                		html.push('<div class="row"><div class="item-input col-100"><textarea ua="" fen="0" name="jd" readonly placeholder="" /></textarea></div></div>');
	                                	}
			                        	html.push('</div></div>');
	                            	}else{
	                            		var xxlist = data[a].xx;//四个选项
	                            		var daanarr=[];
	                            		console.log(daanarr);
	                            		if(ksda){
	                            			daanarr = ksda.split(',');
	                            		}
	                            		console.log(daanarr);
	                            		switch (data[a].tx){
	                            			case 'danxuan':
	                            			html.push('<div class="title" tx="' + data[a].tx + '"><span class="subtype">单选</span>');
	                            			break;
	                            			case 'duoxuan':
	                            			html.push('<div class="title" tx="' + data[a].tx + '"><span class="subtype">不定项</span>');
	                            			break;
	                            			case 'panduan':
	                            			html.push('<div class="title" tx="' + data[a].tx + '"><span class="subtype">判断</span>');
	                            			break;
	                            			
	                            		}
	                            		html.push('<span>(' + a + ').' + data[a].title + '</span></div>');
	                            		html.push('<ul class="answer">');
	                            		if(data[a].tx=="danxuan"||data[a].tx =="duoxuan"){
		                            		for (var sck in xxlist) {
//		                            			console.log(sck);
//		                            			console.log(daanarr);
				                                if ($.inArray(sck, daanarr) >= 0) {
				                                	
				                                    html.push('<li class="active">' + xxlist[sck].xx + '</li>');
				                                } else {
				                                    html.push('<li>' + xxlist[sck].xx + '</li>');
				                                }
				                            }
	                              		}else if (data[a].tx =="panduan") {
	                              			if(ksda){
	                              				if (ksda== '0') {
				                                	html.push('<li>对</li>');
				                                	html.push('<li class="active">错</li>');
				                                } else if(ksda=='1'){
				                                	html.push('<li class="active">对</li>');
				                                	html.push('<li>错</li>');
				                                }else {
				                                    html.push('<li>对</li>');
				                                	html.push('<li>错</li>');
			                                	}
	                              			}else{
			                                	html.push('<li>对</li>');
			                                	html.push('<li>错</li>');
	                              			}
	                              			
	                            		}
				                    html.push('</ul>');
				                    }
	                            	html.push('</li>');
	                            }
	                            html.push('</ul></div>');
	                        }
                            html.push('</ul>');
                            html.push('</div>');
                            html.push('<div class="analysis">');
                            html.push('<h1 class="title">本题得分:'+defen+'</h1>');
                            if(item.shititypeid < 3){
	                        	html.push('<h1 class="title">正确答案：');
	                            for (var zf = 0; zf < item.daan.split(',').length; zf++) {
	                                html.push(arr[item.daan.split(',')[zf] - 1]);
	                            }
	                            html.push('</h1>');
	                        }else if (item.shititypeid == 3) {
	                            if (item.daan == '1') {
	                                html.push('<h1 class="title">正确答案：对</h1>');
	                            } else {
	                                html.push('<h1 class="title">正确答案：错</h1>');
	                            }
	                        } else if(item.shititypeid == 4){
	                            html.push('<h1 class="title">正确答案：</h1>');
	                            var daan=JSON.parse(item.daan);
	                            for (var a  in daan) {
	                         		var zqda=daan[a].kong; 
	                         		var reg=/#/g;
	                         		zqda=zqda.replace(reg,' ');
	                         		html.push('<div class="row"><div class="item-title col-10">('+ a +')</div><div class="item-input col-90"><input type="text" ua="" fen="0" name="tk" index='+ a +' placeholder="'+ zqda +'" /></div></div>');
	                            }
	                        }else if(item.shititypeid == 5){
	                        	html.push('<h1 class="title">正确答案：</h1>');
	                        	html.push('<div class="content">' + item.daan + '</div>');
	                        }else if(item.shititypeid == 6){
	                        	html.push('<h1 class="title">正确答案：</h1>');
	                        	var zqda_arr=JSON.parse(item.data);
	                        	for(var a  in zqda_arr){
	                        		var daan=' ';
	                        		if(zqda_arr[a].tx=='danxuan'){
				                        daan=arr[zqda_arr[a].daan];
	                        		}else if(zqda_arr[a].tx=='duoxuan'){
	                        			for (var zf = 0; zf < zqda_arr[a].daan.split(',').length; zf++) {
	                        				if(daan==" "){
	                        					daan=arr[zqda_arr[a].daan.split(',')[zf]-1];
	                        				}else{
	                        					daan=daan+"、"+arr[zqda_arr[a].daan.split(',')[zf]-1];
	                        				}
			                            }
	                        		}else if(zqda_arr[a].tx=='panduan'){
	                        			if (zqda_arr[a].daan == '1') {
			                                daan="对";
			                            } else {
			                                daan="错";
			                            }
	                        		}else if(zqda_arr[a].tx=='jianda'){
	                        			daan=zqda_arr[a].daan;
	                        		}
	                        		html.push('<div class="content">' );
	                    			html.push('<div class="row"><div class="item-title col-10">('+ a +')</div><div class="item-input col-90">'+daan+'</div></div>');
	                    			html.push('</div>');
	                        	}
	                        }
                            html.push('<h1 class="title">答案解析</h1>');
                            html.push('<div class="content">' + item.jieda + '</div>');
                            html.push('</div>');

                            html.push('</li>');
                        }
                    }
                }
            }

            that.analysisList.html(html.join(''));

            var lilist = that.analysisList.find('.exercise');

            for (var li = 0; li < lilist.length; li++) {
                $(lilist[li]).attr('label', $(lilist[li]).index() + 1);
                $(lilist[li]).find('.label').html($(lilist[li]).index() + 1);
            }

            //未答和总题数
            var noan = 0;
            for (var x = 0; x < that.analysisList.find('.exercise').length; x++) {
                var qs = that.analysisList.find('.exercise')[x];
                if ($(qs).attr('ua') != '') {
                    noan++;
                }
            }
            that.answered.text(noan);
            that.noanswer.text(that.analysisList.find('.exercise').length - noan);
            that.matter.text(that.analysisList.find('.exercise').length);

            //第一题默认显示
            $(that.analysisList.find('.exercise')[0]).addClass('show');

            //答案按钮事件
            that.btnsignClick();
            //上一题按钮事件
            that.btnprevClick();
            //下一题按钮事件
            that.btnnextClick();
            //答题卡展开事件
            that.landing();

        });

    };

    //答案按钮事件
    myexercise.prototype.btnsignClick = function () {
        var that = this;

        that.btnsign.off('click').on('click', function () {
            that.analysisList.find('.show').addClass('sign');
            that.analysisList.find('.show .analysis').removeClass('hidden');

            that.signed.text(that.analysisList.find('.sign').length);
        });
    };

    //上一题按钮事件
    myexercise.prototype.btnprevClick = function () {
        var that = this;
        var Exercise = that.page.find('.exercise');

        that.btnprev.off('click').on('click', function () {
            var Label = that.analysisList.find('.show').attr('label');

            if (Label > 1) {
                that.btnnext.text('下一题');
                Exercise.removeClass('show');
                Exercise.eq(Label - 1).addClass('show');
                that.seen.text(Label - 1);
            } else {
                $.toast('已经是第一题了');
            }
        });
    };

    //下一题按钮事件
    myexercise.prototype.btnnextClick = function () {
        var that = this;
        var Exercise = that.analysisList.find('.exercise');

        that.btnnext.off('click').on('click', function () {
            var matter = parseInt(that.matter.text());

            var Label = that.analysisList.find('.show').attr('label');

            if (Label >= matter) {
                $.toast('已经是最后一题了');
                that.seen.text(Label);
            } else {
                Exercise.removeClass('show');
                Exercise.eq(Label).addClass('show');
                that.seen.text(parseInt(Label) + 1);
            }
        });
    };

    //答题卡展开事件
    myexercise.prototype.landing = function () {
        var that = this;
        var Status, Sign;

        $(document).on('click', '#btnOpen', function () {
            var signed = that.signed.text();
            var answered = that.answered.text();
            var noanswer = that.noanswer.text();
            var seen = that.seen.text();
            var matter = that.matter.text();
            var Exercise = that.analysisList.find('.exercise');
            var html = [];

            html.push('<div class="popup answercard">');

            html.push('<div class="subinfo bgwirte">');
            html.push('<div class="row no-gutter">');

            html.push('<div class="col-25">');
            html.push('<span>标记</span>');
            html.push('<span>' + signed + '</span>');
            html.push('</div>');

            html.push('<div class="col-25">');
            html.push('<span>已答</span>');
            html.push('<span>' + answered + '</span>');
            html.push('</div>');

            html.push('<div class="col-25">');
            html.push('<span>未答</span>');
            html.push('<span>' + noanswer + '</span>');
            html.push('</div>');

            html.push('<div class="col-25 close-popup">');
            html.push('<span class="icon icon-card"></span>');
            html.push('<span>' + seen + '</span>/<span>' + matter + '</span>');
            html.push('</div>');

            html.push('</div>');
            html.push('</div>');

            html.push('<div class="row no-gutter qcon">');
            for (var i = 1; i <= Exercise.length; i++) {
                Status = Exercise.eq(i - 1).attr('status');
                Sign = Exercise.eq(i - 1).hasClass('sign');

                if (Sign) {
                    //已标记
                    html.push('<div class="col-15 close-popup wrong">' + i + '</div>');
                } else if (Status == '1') {
                    //已答
                    html.push('<div class="col-15 close-popup right">' + i + '</div>');
                } else {
                    html.push('<div class="col-15 close-popup">' + i + '</div>');
                }
            }
            html.push('</div>');

            html.push('</div>');

            var popupHTML = html.join('');

            $.popup(popupHTML);

            //点击题号跳到对应题目
            for (var s = 0; s <= Exercise.length; s++) {
                $('.qcon .col-15').eq(s).off('click').on('click', function () {
                    Exercise.removeClass('show');
                    Exercise.eq($(this).text() - 1).addClass('show');

                    that.seen.text(that.analysisList.find('.show').attr('label'))
                })
            }
        });
    };

    exports.init = function (e, id, page) {

        var $page = $(page);

        var obj = $page.attr('page');

        if (!obj) {
            obj = new myexercise(e, id, $page);
        } else {
            $page.attr('page', obj);
        }
        return obj;
    };
});