define(function(require, exports) {
	//公用类
	var common = require('common');
	//菜单
	//var menu = require('menu');
	//左边菜单
	var leftmenu = require('leftmenu');
	//获取用户ID
	var locuid = localStorage.getItem('userid');
	//获取用户已经选择的单词分类筛选规则
	var userclassify = localStorage.getItem('wordclassifydata');
	var application = function(e, id, page) {
		var that = this;
		this.page = page; //页面

		$(document).on("click", '.icon-menu', function() {
			$.openPanel("#panel-screen");
		});
		//侧栏菜单
		if(locuid == null) {
			this.page.find('.open-panel').on('click', function() {
				$.toast('更多功能在登录之后回来');
				setTimeout(function() {
					$.router.load('../login.html');
				}, 3000);
			});
		} else {
			leftmenu.showmenu(this.page);
		}
		//页面加载
		this.PageLoad();
		//菜单
		//menu.showmenu(this.page, '1');
	};
	//页面加载
	application.prototype.PageLoad = function() {
		var that = this;
		var baseurl = localStorage.getItem('base');
		/* var baseurl = "localhost:8080/mobileMta";  */
		common.get('/getWordClassify.html', function(res) {
			
			var html = [];
			//			html.push('<li class="classlist active">全部</li>');
			if(res.length > 0) {
				for(var i = 0; i < res.length; i++) {
					if(res[i].children != null) {
						html.push('<li class=" haschildren" classifyid="' + res[i].classifyid + '">' + '<p class="booktitle">' + res[i].name + '</p>');
						html.push('<ul style="display:none">')
						for(var j = 0; j < res[i].children.length; j++) {
							html.push('<li class="childlist" classifyid="' + res[i].children[j].classifyid + '">' + res[i].children[j].name + '</li>')
						}
						html.push('</ul>')
						html.push('</li>')
					} else {
						html.push('<li class="classlist" classifyid="' + res[i].classifyid + '">' + res[i].name + '</li>');
					}
				}
			}
			$("#wordTypeUl").html(html.join(''));
			//点击分类选项，本地存储用户选择的筛选规则
			that.clickli();
		})
	};
	//点击分类选项，本地存储用户选择的筛选规则
	application.prototype.clickli = function() {
		var that = this,
			wordclassifydata = {};
			console.log(userclassify)
		if(userclassify != null) {
			var data = JSON.parse(userclassify);
			var lastchoosetype = data.classifyid;
			$("#wordTypeUl").find('li').removeClass('active');
			$("#wordTypeUl").find("li[classifyid='" + lastchoosetype + "']").addClass('active');
		}

		//选择分类
		$("#wordTypeUl").find('.booktitle').off("click").on("click", function() {
			if($(this).hasClass("isshow")) {
				$(this).siblings("ul").hide();
				$(this).removeClass("isshow")
			} else {
				$(this).siblings("ul").show();
				$(this).addClass("isshow")
			}
		})
		//存储选择的选项
		$("#wordTypeUl").find('.childlist').off("click").on("click", function() {
			$("#wordTypeUl").find('li').removeClass('active');
			$(this).addClass('active');
			var type = $(this).attr('classifyid');
			wordclassifydata.classifyid = type;
			console.log(wordclassifydata)
			localStorage.setItem('wordclassifydata', JSON.stringify(wordclassifydata));

		})

	};
	//点击确定页面跳转
	$("#btnscr").off("click").on("click", function() {
		if(localStorage.getItem("wordclassifydata")==null){
			$.toast("请选择分类")
			return;
		}
		$.router.load("word_prictise.html")
	})

	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.data('page');

		if(!obj) {
			obj = new application(e, id, $page);
		} else {
			$page.data('page', obj);
		}
		return obj;
	};
});