/**
 * Created by alex-mac on 16/1/11.
 *
 */
	
	  // 注册返回按键事件  
//  plus.key.addEventListener('backbutton', function() {  
//      // 事件处理  
//      plus.nativeUI.confirm("退出程序？", function(event) {  
//          if (event.index) {  
//              plus.runtime.quit();  
//          }  
//      }, null, ["取消", "确定"]);  
//  }, false);  
define(function(require, exports, module) {
	Array.prototype.indexOf = function(val) {
		for(var i = 0; i < this.length; i += 1) {
			if(this[i] == val) {
				return i
			}
		}
		return -1
	};
	Array.prototype.remove = function(val) {
		var index = this.indexOf(val);
		if(index > -1) {
			this.splice(index, 1)
		}
	};
	String.prototype.format = function(args) {
		var result = this;
		if(arguments.length > 0) {
			if(arguments.length == 1 && typeof(args) == "object") {
				for(var key in args) {
					if(args[key] != undefined) {
						var reg = new RegExp("({" + key + "})", "g");
						result = result.replace(reg, args[key])
					}
				}
			} else {
				for(var i = 0; i < arguments.length; i += 1) {
					if(arguments[i] != undefined) {
						result = result.replace(new RegExp("({)" + i + "(})", "g"), arguments[i])
					}
				}
			}
		}
		return result
	};
	String.prototype.padLeft = function(len, ch) {
		ch = typeof(ch) === 'undefined' ? ' ' : ch;
		var s = String(this);
		while(s.length < len) {
			s = ch + s
		}
		return s
	};
	Date.prototype.Format = function(fmt) {
		var o = {
			"M+": this.getMonth() + 1,
			"d+": this.getDate(),
			"h+": this.getHours(),
			"m+": this.getMinutes(),
			"s+": this.getSeconds(),
			"q+": Math.floor((this.getMonth() + 3) / 3),
			"S": this.getMilliseconds()
		};
		if(/(y+)/.test(fmt)) {
			fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length))
		}
		for(var k in o) {
			if(new RegExp("(" + k + ")").test(fmt)) {
				fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)))
			}
		}
		return fmt
	};
	var common = {
		router: false,
		uniqueId: 1,
		sessionKey: 'customer',
		queryString: function(item) {
			var value = location.search.match(new RegExp("[\?\&]" + item + "=([^\&]*)(\&?)", "i"));
			return value ? value[1] : value
		},
		redirectURL: function(url) {
			if(this.router) {
				$.router.loadPage(url)
			} else {
				if(url.indexOf("/") == 0) {
					var href = location.href;
					var re = new RegExp('^file.*www');
					if(href.indexOf("file") == 0) {
						var base = re.exec(href);
						location.href = base + url
					} else {
						location.href = url
					}
				} else {
					location.href = url
				}
			}
		},
		setLoginOut: function(callback) {
			this.removelocalStorage(this.sessionKey);
			if(typeof callback == 'function') {
				callback()
			}
		},
		setLogin: function(value) {
			this.setlocalStorage(this.sessionKey, value)
		},
		getCurrentUser: function(callback) {
			console.log('获取当前登录用户');
			var data = localStorage.getItem(this.sessionKey) || '';
			if(typeof callback == 'function') {
				console.log('执行回调');
				callback(this, data)
			} else {
				if(data.length > 0) {
					console.log('存在当前登录用户');
					console.log('当前登录用户:' + data);
					return JSON.parse(data)
				}
				console.log('没有登录');
				this.redirectURL('/me/login.html')
			}
		},
		setlocalStorage: function(key, value) {
			localStorage.removeItem(key);
			localStorage.setItem(key, JSON.stringify(value))
		},
		getlocalStorage: function(key) {
			var data = localStorage.getItem(key) || '';
			if(data.length > 0) {
				return JSON.parse(data)
			}
			return null
		},
		removelocalStorage: function(key) {
			localStorage.removeItem(key)
		},
		showloading: function() {
			$.showIndicator()
		},
		hideloading: function() {
			$.hideIndicator()
		},
		get: function(url, parms, callback, error) {
			var that = this;
			$.ajax({
				type: 'GET',
				beforeSend: that.showloading(),
				url: baseURL + url,
				cache: false,
				data: parms,
				success: function(res) {
					if(res != '' && res != null) {
						res = JSON.parse(res);
						
					}
					that.hideloading();
					if(typeof parms == "function") {
						parms(res)
					}
					if(typeof callback == 'function') {
						callback(res)
					}
				},
				error: function(res) {
					that.hideloading();
					that.error_hander(res);
					if(typeof error == 'function') {
						error(res)
					}
				}
			})
		},
		post: function(url, parms, callback, error) {
			var that = this;
			$.ajax({
				type: 'POST',
				beforeSend: that.showloading(),
			    url: baseURL + url,
				data: parms,
				success: function(res) {
					res = JSON.parse(res);
					that.hideloading();
					if(typeof callback == 'function') {
						callback(res)
					}
				},
				error: function(res) {
					that.hideloading();
					that.error_hander(res);
					if(typeof error == 'function') {
						error(res)
					}
				}
			})
		},
		error_hander: function(response) {
			console.log(response)
//			common.toast('通信出现异常')
		},
		toast: function(message) {
			$.toast(message)
		},
		hander: function(data) {},
		clone: function clone(obj) {
			var result = {};
			for(key in obj) {
				result[key] = obj[key]
			}
			return result
		},
		prompt: function(options) {
			var defaults = {
				title: '请输入内容',
				placeholder: "",
				allowNull: false,
				value: '',
				inputClass: 'modalinput',
				maxLength: 0,
				minLength: 0,
				ok: null
			};
			$.extend(true, defaults, options);
			var input = [];
			input.push('<input');
			input.push(' type="text" ');
			input.push(' class="' + defaults.inputClass + '" ');
			input.push(' placeholder="' + defaults.placeholder + '"');
			if(defaults.maxLength > 0) {
				input.push(' maxlength="' + defaults.maxLength + '"')
			}
			input.push(' value="' + defaults.value + '" ');
			input.push('/>');
			input.push('<p class="modaltip"></p>');
			$.modal({
				title: defaults.title,
				text: input.join(''),
				buttons: [{
					text: '取消'
				}, {
					text: '确定',
					close: false
				}],
				onClick: function(modal, index) {
					if(index == 0) {
						return
					}
					var value = $(modal).find('.' + defaults.inputClass).val() || '';
					var len = value.trim().length;
					var tip = $(modal).find('.modaltip');
					if(len == 0 && !defaults.allowNull) {
						tip.text('该项为必填项').show();
						return false
					}
					if(len < defaults.minLength) {
						tip.text('输入的内容不得小于' + defaults.minLength + '个字符').show();
						return false
					}
					if(len > defaults.maxLength) {
						tip.text('输入的内容不得大于' + defaults.maxLength + '个字符').show();
						return false
					}
					defaults.ok(value);
					$.closeModal()
				}
			})
		}
	};
	module.exports = common
});