/**
 * Created by X01 on 2016-04-18.
 */
define(function(require, exports) {
	//公用类
	var common = require('common');

	//获取用户ID
	var locuid = localStorage.getItem('userid');
	//获取UUID
	var uuid = location.href.split('=')[1];

	var test = function(e, id, page) {
		var that = this;
		that.page = page; //页面

		//考试名称
		that.exertitle = page.find('#exertitle');
		//计时器
		that.coster = page.find('#coster');

		//题目列表
		that.analysisList = page.find('#analysisList');
		//题目
		that.Exercise = that.analysisList.find('.exercise');
		//标记(答案)按钮
		that.btnsign = page.find('#btnsign');
		//上一题按钮
		that.btnprev = page.find('#btnprev');
		//下一题按钮
		that.btnnext = page.find('#btnnext');

		//标记(答案)计数label
		that.sign = page.find('.sign');
		//答案查看次数
		that.signed = page.find('#signed');
		//已答题数
		that.answered = page.find('#answered');
		//未答题数
		that.noanswer = page.find('#noanswer');
		//已经做过的题数
		that.seen = page.find('#seen');
		//总题数
		that.matter = page.find('#matter');

		if(uuid == 'wrongExerciseInfo') {
			//错题练习加载
			that.wrongExerciseInfo();
		} else {
			//在线练习加载
			that.exerciseInfo();
		}

	};

	//错题练习加载
	test.prototype.wrongExerciseInfo = function() {
		var that = this;
		var html = [];

		common.get('/wrongExerciseInfo.html', {
			userid: locuid
		}, function(res) {
			//			console.log(res);
			var html = [];
			//字符数组
			var arr = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S',
				'T', 'U', 'V', 'W', 'X', 'Y', 'Z'
			];

			//考试名称
			that.exertitle.html('错题练习');

			if(res.res == 1) {
				//考试题目列表
				var dXtmixlist = JSON.parse(res.dXtmix);

				if(dXtmixlist) {
					for(var b in dXtmixlist) {
						var dxdata = dXtmixlist[b].data;
						for(var d = 1; d < dxdata.length + 1; d++) {
							var item = dxdata[d - 1];

							if(item.shititypeid < 4) {

								html.push('<li class="exercise bgwirte nomargin" label="' + d +
									'" sid="' + item.qsnid + '" daan="' + item.daan +
									'" ua="">');

								html.push('<div class="subject">');

								switch(item.shititypeid) {
									case 1:
										html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">单选</span>');
										break;
									case 2:
										html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">多选</span>');
										break;
									case 3:
										html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">判断</span>');
										break;
									default:
										html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">其他</span>');
								}

								html.push('<span class="label">' + d + '</span>.<span>' + thetitle + '</span></div>');
								html.push('<ul class="answer">');

								if(item.shititypeid == 3) {
									html.push('<li>对</li>');
									html.push('<li>错</li>');
								} else if(item.shititypeid == 4) {
									html.push('<div class="nomsg">移动端不应该有填空题</div>');
								} else if(item.shititypeid == 5) {
									html.push('<div class="nomsg">移动端不应该有简答题</div>');
								} else if(item.shititypeid == 6) {
									html.push('<div class="nomsg">移动端不应该有阅读理解题</div>');
								} else {
									var dxlist = JSON.parse(item.xx);
									for(var dx in dxlist) {
										html.push('<li>' + dxlist[dx].xx + '</li>');
									}
								}

								html.push('</ul>');
								html.push('</div>');

								html.push('<div class="analysis hidden">');
								if(item.shititypeid == 3) {
									if(item.daan == '1') {
										html.push('<h1 class="title">正确答案：A</h1>');
									} else {
										html.push('<h1 class="title">正确答案：B</h1>');
									}
								} else {
									html.push('<h1 class="title">正确答案：');
									for(var zf = 0; zf < item.daan.split(',').length; zf++) {
										html.push(arr[item.daan.split(',')[zf] - 1]);
									}
									html.push('</h1>');
								}
								html.push('<h1 class="title">答案解析</h1>');
								html.push('<div class="content">' + item.jieda + '</div>');
								html.push('</div>');

								html.push('</li>');
							}
						}
					}
				}

				that.analysisList.html(html.join(''));
				that.page.find('.btnrow').removeClass('hidden');
				that.page.find('.subinfo').removeClass('hidden');

				//未答和总题数
				var noan = 0;
				for(var x = 0; x < that.analysisList.find('.exercise').length; x++) {
					var qs = that.analysisList.find('.exercise')[x];
					if($(qs).attr('ua') != '') {
						noan++;
					}
				}
				that.answered.text(noan);
				that.noanswer.text(that.analysisList.find('.exercise').length - noan);
				that.matter.text(that.analysisList.find('.exercise').length);

				//第一题默认显示
				$(that.analysisList.find('.exercise')[0]).addClass('show');

				//标记按钮事件
				that.btnsignClick();
				//上一题按钮事件
				that.btnprevClick();
				//下一题按钮事件
				that.btnnextClick();
				//答案选择事件
				that.AnswerChoose();

				//答题卡展开事件
				that.landing();
			} else {
				that.analysisList.html('<div class="nomsg">还没有错题练习</div>');
			}
		});
	};

	//在线练习加载
	test.prototype.exerciseInfo = function() {
		var that = this;
		var html = [];

		common.post('/exerciseInfo.html', {
			userid: locuid,
			euuid: uuid
		}, function(res) {
			//			console.log(res)
			var html = [];
			//字符数组
			var arr = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S',
				'T', 'U', 'V', 'W', 'X', 'Y', 'Z'
			];

			//考试名称
			that.exertitle.html(res.name);

			//考试题目列表
			var analysislist = JSON.parse(res.shijuanData.dShitimix).data;
			//			console.log(analysislist)
			if(analysislist) {
				for(var a in analysislist) {
					var item = analysislist[a];

					if(item.title.indexOf("video")) {
						var local = localStorage.getItem("base");
						var thetitle = item.title.replace('"/upload/video/', '"http://dute.dutpbook.com/upload/video/');
						var thetitle = thetitle.replace('"/upload/video/', '"http://dute.dutpbook.com/upload/video/');
					}

					if(item.shititypeid < 4) {

						html.push('<li class="exercise bgwirte nomargin" label="' + a +
							'" sid="' + item.qsnid + '" fen="' + item.fen + '" ua=""' +
							'" daan="' + item.daan + '" type="ds">');

						html.push('<div class="subject">');

						switch(item.shititypeid) {
							case 1:
								html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">单选</span>');
								break;
							case 2:
								html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">多选</span>');
								break;
							case 3:
								html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">判断</span>');
								break;
							default:
								html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">其他</span>');
						}

						html.push('<span>' + a + '.' + thetitle + '</span></div>');
						html.push('<ul class="answer">');

						if(item.shititypeid == 3) {
							html.push('<li>对</li>');
							html.push('<li>错</li>');
						} else if(item.shititypeid == 4) {
							html.push('<div class="nomsg">移动端不应该有填空题</div>');
						} else if(item.shititypeid == 5) {
							html.push('<div class="nomsg">移动端不应该有简答题</div>');
						} else if(item.shititypeid == 6) {
							html.push('<div class="nomsg">移动端不应该有阅读理解题</div>');
						} else {
							var xxlist = JSON.parse(item.xx);
							for(var k in xxlist) {
								html.push('<li>' + xxlist[k].xx + '</li>');
							}
						}

						html.push('</ul>');
						html.push('</div>');

						html.push('<div class="analysis hidden">');
						if(item.shititypeid == 3) {
							if(item.daan == '1') {
								html.push('<h1 class="title">正确答案：A</h1>');
							} else {
								html.push('<h1 class="title">正确答案：B</h1>');
							}
						} else {
							html.push('<h1 class="title">正确答案：');
							for(var zf = 0; zf < item.daan.split(',').length; zf++) {
								html.push(arr[item.daan.split(',')[zf] - 1]);
							}
							html.push('</h1>');
						}
						html.push('<h1 class="title">答案解析</h1>');
						html.push('<div class="content">' + item.jieda + '</div>');
						html.push('</div>');

						html.push('</li>');
					}
				}
			}

			//考试随机题目列表

			//==========================
			//debug：2017-1-22 14:28:17
			//author：Joshua
			//desc:修改随机题数据解码错误，data属性要在集合内部解码
			//==========================
			var dXtmixlist = JSON.parse(res.shijuanData.dXtmix);
			//var dXtmixlist = JSON.parse(res.shijuanData.dXtmix).data;

			//			console.log(JSON.parse(res.shijuanData.dXtmix));

			if(dXtmixlist) {
				for(var b in dXtmixlist) {
					var dxdata = dXtmixlist[b].data;

					for(var d = 1; d < dxdata.length; d++) {
						var item = dxdata[d];

						if(item.shititypeid < 4) {

							html.push('<li class="exercise bgwirte nomargin" label="' + d +
								'" sid="' + item.qsnid +
								'" daan="' + item.daan +
								'" visited="true" status="1" type="dx">');

							html.push('<div class="subject">');

							switch(item.shititypeid) {
								case 1:
									html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">单选</span>');
									break;
								case 2:
									html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">多选</span>');
									break;
								case 3:
									html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">判断</span>');
									break;
								default:
									html.push('<div class="title" tx="' + item.shititypeid + '"><span class="subtype">其他</span>');
							}

							html.push('<span class="label">' + d + '</span>.<span>' + thetitle + '</span></div>');
							html.push('<ul class="answer">');

							if(item.shititypeid == 3) {
								html.push('<li>对</li>');
								html.push('<li>错</li>');
							} else if(item.shititypeid == 4) {
								html.push('<div class="nomsg">移动端不应该有填空题</div>');
							} else if(item.shititypeid == 5) {
								html.push('<div class="nomsg">移动端不应该有简答题</div>');
							} else if(item.shititypeid == 6) {
								html.push('<div class="nomsg">移动端不应该有阅读理解题</div>');
							} else {
								var dxlist = JSON.parse(item.xx);
								for(var dx in dxlist) {
									html.push('<li>' + dxlist[dx].xx + '</li>');
								}
							}

							html.push('</ul>');
							html.push('</div>');

							html.push('<div class="analysis hidden">');
							if(item.shititypeid == 3) {
								if(item.daan == '1') {
									html.push('<h1 class="title">正确答案：A</h1>');
								} else {
									html.push('<h1 class="title">正确答案：B</h1>');
								}
							} else {
								html.push('<h1 class="title">正确答案：');
								for(var zf = 0; zf < item.daan.split(',').length; zf++) {
									html.push(arr[item.daan.split(',')[zf] - 1]);
								}
								html.push('</h1>');
							}
							html.push('<h1 class="title">答案解析</h1>');
							html.push('<div class="content">' + item.jieda + '</div>');
							html.push('</div>');

							html.push('</li>');
						}
					}
				}
			}

			that.analysisList.html(html.join(''));
			that.page.find('.btnrow').removeClass('hidden');
			that.page.find('.subinfo').removeClass('hidden');

			//未答和总题数
			var noan = 0;
			for(var x = 0; x < that.analysisList.find('.exercise').length; x++) {
				var qs = that.analysisList.find('.exercise')[x];
				if($(qs).attr('ua') != '') {
					noan++;
				}
			}
			that.answered.text(noan);
			that.noanswer.text(that.analysisList.find('.exercise').length - noan);
			that.matter.text(that.analysisList.find('.exercise').length);

			//第一题默认显示
			$(that.analysisList.find('.exercise')[0]).addClass('show');

			//标记按钮事件
			that.btnsignClick();
			//上一题按钮事件
			that.btnprevClick();
			//下一题按钮事件
			that.btnnextClick();
			//答案选择事件
			that.AnswerChoose();

			//答题卡展开事件
			that.landing();
		});
	};

	//标记按钮事件
	test.prototype.btnsignClick = function() {
		var that = this;

		that.btnsign.off('click').on('click', function() {
			that.analysisList.find('.show').addClass('sign');
			that.analysisList.find('.show .analysis').removeClass('hidden');

			that.signed.text(that.analysisList.find('.sign').length);
		});
	};

	//暂停正在播放的音视频
	function video_pause() {
		var videoarr = $("video");
		for(var i = 0; i < videoarr.length; i++) {
			videoarr[i].pause();			
		}
	}
	//上一题按钮事件
	test.prototype.btnprevClick = function() {
		var that = this;
		var Exercise = that.page.find('.exercise');

		that.btnprev.off('click').on('click', function() {
			var Label = that.analysisList.find('.show').attr('label');
			video_pause();
			if(Label > 1) {
				that.btnnext.text('下一题');
				Exercise.removeClass('show');
				Exercise.eq(Label - 2).addClass('show');
				that.seen.text(Label - 1);
			} else {
				$.toast('已经是第一题了');
			}
		});
	};

	//下一题按钮事件
	test.prototype.btnnextClick = function() {
		var that = this;
		var Exercise = that.analysisList.find('.exercise');

		that.btnnext.off('click').on('click', function() {
			video_pause();
			var matter = parseInt(that.matter.text());

			var Label = that.analysisList.find('.show').attr('label');

			if(Label >= matter) {
				$.toast('已经是最后一题了');
				that.seen.text(Label);
			} else {
				Exercise.removeClass('show');
				Exercise.eq(Label).addClass('show');
				that.seen.text(parseInt(Label) + 1);
			}
		});
	};

	//答题选择
	test.prototype.AnswerChoose = function() {
		var that = this;
		var Exercise = that.analysisList.find('.exercise');
		var answers = Exercise.find('.answer li');

		answers.off('click').on('click', function() {
			var answered = parseInt(that.answered.text());
			var noanswer = parseInt(that.noanswer.text());
			var visited = that.analysisList.find('.show').attr('visited');
			var fen = that.analysisList.find('.show').attr('fen');
			var daan = that.analysisList.find('.show').attr('daan');
			var tx = that.analysisList.find('.show .title').attr('tx');
			var ua = [];

			switch(tx) {
				case '1':
					//单选
					$(this).parents('.answer').find('li').removeClass();
					$(this).addClass('active');

					that.analysisList.find('.show').attr({
						'status': '1',
						'ua': that.page.find('.show .active').index() + 1
					});

					if(daan == that.page.find('.show .active').index() + 1) {
						$(this).addClass('true');
					} else {
						$(this).addClass('false');
					}

					if(visited != 'true') {
						if(that.analysisList.find('.show li').hasClass('active')) {
							answered++;
							noanswer--;
							that.answered.text(answered);
							that.noanswer.text(noanswer);

							that.analysisList.find('.show').attr('visited', 'true');
						}
					}
					break;
				case '2':
					//多选
					that.analysisList.find('.show').attr('status', '1');

					if(!$(this).hasClass('active')) {
						var daanarr = daan.split(',');
						for(var da = 0; da < daanarr.length; da++) {
							var _index = $(this).index() + 1;

							if($.inArray(_index.toString(), daanarr) != -1) {
								$(this).addClass('active true');
							} else {
								$(this).addClass('active false');
							}
						}
					}

					if(visited != 'true') {
						if(that.analysisList.find('.show li').hasClass('active')) {
							answered++;
							noanswer--;
							that.answered.text(answered);
							that.noanswer.text(noanswer);

							for(var an = 0; an < that.analysisList.find('.show .active').length; an++) {
								var item = that.analysisList.find('.show .active')[an];

								ua.push($(item).index() + 1);
							}

							that.analysisList.find('.show').attr('ua', ua.join(','));

							that.analysisList.find('.show').attr({
								'visited': 'true',
								'ua': ua.join(',')
							});
						}
					}
					break;
				case '3':
					//判断
					$(this).parents('.answer').find('li').removeClass();
					$(this).addClass('active');

					that.analysisList.find('.show').attr({
						'status': '1',
						'ua': that.page.find('.show .active').index()
					});

					var sss = '';
					if(daan == 0) {
						sss = "错"
					} else {
						sss = "对"
					}
					if(sss == that.page.find('.show .active').html()) {
						$(this).addClass('true');
					} else {
						$(this).addClass('false');
					}

					if(visited != 'true') {
						if(that.analysisList.find('.show li').hasClass('active')) {
							answered++;
							noanswer--;
							that.answered.text(answered);
							that.noanswer.text(noanswer);

							that.analysisList.find('.show').attr('visited', 'true');
						}
					}
					break;
			}

			//得分
			if(daan == that.analysisList.find('.show').attr('ua')) {
				that.analysisList.find('.show').attr('defen', fen);
			} else {
				that.analysisList.find('.show').attr('defen', '0');
			}

		});
	};

	//答题卡展开事件
	test.prototype.landing = function() {
		var that = this;
		var Status, Sign;

		$(document).on('click', '#btnOpen', function() {
			var signed = that.signed.text();
			var answered = that.answered.text();
			var noanswer = that.noanswer.text();
			var seen = that.seen.text();
			var matter = that.matter.text();
			var Exercise = that.analysisList.find('.exercise');
			var html = [];

			html.push('<div class="popup answercard">');

			html.push('<div class="subinfo bgwirte">');
			html.push('<div class="row no-gutter">');

			html.push('<div class="col-25">');
			html.push('<span>答案</span>');
			html.push('<span>' + signed + '</span>');
			html.push('</div>');

			html.push('<div class="col-25">');
			html.push('<span>已答</span>');
			html.push('<span>' + answered + '</span>');
			html.push('</div>');

			html.push('<div class="col-25">');
			html.push('<span>未答</span>');
			html.push('<span>' + noanswer + '</span>');
			html.push('</div>');

			html.push('<div class="col-25 close-popup">');
			html.push('<span class="icon icon-card"></span>');
			html.push('<span>' + seen + '</span>/<span>' + matter + '</span>');
			html.push('</div>');

			html.push('</div>');
			html.push('</div>');

			html.push('<div class="row no-gutter qcon">');
			for(var i = 1; i <= Exercise.length; i++) {
				Status = Exercise.eq(i - 1).attr('status');
				Sign = Exercise.eq(i - 1).hasClass('sign');

				if(Sign) {
					//已标记
					html.push('<div class="col-15 close-popup wrong">' + i + '</div>');
				} else if(Status == '1') {
					//已答
					html.push('<div class="col-15 close-popup right">' + i + '</div>');
				} else {
					html.push('<div class="col-15 close-popup">' + i + '</div>');
				}
			}
			html.push('</div>');

			html.push('</div>');

			var popupHTML = html.join('');

			$.popup(popupHTML);

			//点击题号跳到对应题目
			for(var s = 0; s <= Exercise.length; s++) {
				$('.qcon .col-15').eq(s).off('click').on('click', function() {
					Exercise.removeClass('show');
					Exercise.eq($(this).text() - 1).addClass('show');

					that.seen.text(that.analysisList.find('.show').attr('label'))
				})
			}
		});
	};

	//	console.log($("video").attr("src"))
	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.attr('page');

		if(!obj) {
			obj = new test(e, id, $page);
		} else {
			$page.attr('page', obj);
		}
		return obj;
	};
});