/**
 * Created by X01 on 2016-06-08.
 */

define(function(require, exports) {
	//公用类
	var common = require('common');

	var forgotpwd = function(e, id, page) {
		this.page = page; //页面

		//用户名
		this.codeBtn = page.find('#codeBtn');
		//电话号
		this.tel = page.find('#tel');
		//验证码
		this.telC = page.find('#telCode');
		//重置密码
		this.resetBtn = page.find('#resetBtn');
		this.validate()
		this.getCode();
		this.resetPwd();

	};
	var isPhoneRight = false;
	var isCodeRight = false;
	//生成随机数
	function randomNum(n) {
		var t = '';
		for(var i = 0; i < n; i++) {
			t += Math.floor(Math.random() * 10);
		}
		return t;
	}
	//获取验证码
	forgotpwd.prototype.getCode = function() {
		var that = this;
		var countdown = 60;
		var telCode = randomNum(4);
		that.codeBtn.off('click').on('click', function() {
			var obj = $(this);
			obj.prop("disabled", false);
			var numError = $('div[id="forgotpwd"]').find('div[class="item-input"]').find('span[class="formtips onError"]').length;
			//         if(numError > 0){
			//          	$(that.resetBtn).prop("disabled", true);
			//          }
			//          else{
			//          	$(that.resetBtn).prop("disabled", false);

			localStorage.setItem('yanzhengma', telCode);
			var telNo = that.tel.val();
			var params = {
				"msgContent": telCode,
				"telNo": telNo
			};
			console.log(telCode);
			$.ajax({
				type: 'GET',
				url: 'http://dute.dutpbook.com/mta/sendMsg.html',
				cache: false,
				data: params,
				success: function(res) {},
				error: function(res) {}
			});
			//console.log(params);
			//			common.get('/sendTelCode.html', params, function(res) {
			//				console.log(res);
			//
			//			})

			var interval = setInterval(function() {
				if(countdown == 0) {
					obj.prop("disabled", false);
					obj.val("获取验证码");
					countdown = 60;
					clearInterval(interval);
					return false;
				} else {
					obj.prop("disabled", true);
					obj.val("重新发送(" + countdown + ")");
					countdown--;
				}
			}, 1000);

			//          }
			that.telC.on('change', function() {
				if($(this).val() == telCode) {
					$(that.resetBtn).prop("disabled", false);
				} else {
					$(that.resetBtn).prop("disabled", true);
				}

			});
		})

	};

	//验证
	forgotpwd.prototype.validate = function() {
		var that = this;
		var errorNum = 0;
		//文本框失去焦点后
		$('div[id="forgotpwd"]').find('input').blur(function() {
			var $parent = $(this).parent();
			$parent.find(".formtips").remove();
			//验证手机号
			if($(this).is('#tel')) {
				if(this.value == "") {
					var errorMsg = '手机号必填';
					errorNum++;
					$parent.append('<span class="formtips onError">' + errorMsg + '</span>');
				} else {
					errorNum++;
					if(!(/^1(3|4|5|7|8)\d{9}$/.test($("#tel").val()))) {
						var errorMsg = '请输入正确手机号';
						$parent.append('<span class="formtips onError">' + errorMsg + '</span>');
					} else {
						var okMsg = '<span style="color:#009933" class="icon-normal"></span>';
						$parent.append('<span class="formtips onSuccess">' + okMsg + '</span>');
					}
				}
			}

		}).keyup(function() {
			$(this).triggerHandler("blur");
		})
		return errorNum;
	}

	//获取验证码
	forgotpwd.prototype.resetPwd = function() {
		var that = this;
		var telNo = that.tel.val();
		var telCode = that.telC.val();
		var params = {
			"telNo": telNo,
			"telCode": telCode
		};
		console.log(that.resetBtn)
		that.resetBtn.off('click').on('click', function() {
			if(that.tel.val() !== "" && that.tel.val() !== "") {
				isPhoneRight=true;			
				if(localStorage.getItem("yanzhengma") == that.telC.val()) {
					isCodeRight == true;
					$.router.load('resetPwd.html', true)
				} else {
					$.toast("验证码错误")
				}
			} else {
				$.toast("请输入手机号和验证码")
			}
			
			console.log(isPhoneRight);
			console.log(isCodeRight)
			//验证手机号是否存在，验证码是否正确
//			if(isPhoneRight && isCodeRight) {
//				$.router.load('resetPwd.html', true)
//			}
			localStorage.setItem('tel', that.tel.val());
		})

	}

	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.data('page');

		if(!obj) {
			obj = new forgotpwd(e, id, $page);
		} else {
			$page.data('page', obj);
		}
		return obj;
	};
})