/**
 * Created by X01 on 2016-06-08.
 */

define(function(require, exports) {
	//公用类
	var common = require('common');

	var tel = localStorage.getItem('tel');
	console.log(tel);
	var resetPwd = function(e, id, page) {
		this.page = page; //页面

		this.validate();
		this.update();

	};
	//验证
	resetPwd.prototype.validate = function() {
		var that = this;
		//文本框失去焦点后
		$('div[id="resetPwd"]').find('input').blur(function() {
			var $parent = $(this).parent();
			$parent.find(".formtips").remove();
			//验证密码
			if($(this).is('#pwd')) {
				if(this.value == "") {
					var errorMsg = '密码不能为空';
					$parent.append('<span class="formtips onError">' + errorMsg + '</span>');
				} else {
					var okMsg = '<span style="color:#009933" class="icon-normal"></span>';
					$parent.append('<span class="formtips onSuccess">' + okMsg + '</span>');
				}
			}
			//验证确认密码
			if($(this).is('#pwd2')) {
				var password = $('#pwd').val();
				if(this.value == "" || (this.value != password)) {
					var errorMsg = '两次密码不一致';
					$parent.append('<span class="formtips onError">' + errorMsg + '</span>');
				} else {
					var okMsg = '<span style="color:#009933" class="icon-normal"></span>';
					$parent.append('<span class="formtips onSuccess">' + okMsg + '</span>');
				}
			}

		}).keyup(function() {
			$(this).triggerHandler("blur");
			var numError = $('form .onError').length;
		}).focus(function() {
			$(this).triggerHandler("blur");
		}); //end blur

	}
	//提交
	resetPwd.prototype.update = function() {
		$("#resetBtn").on('click', function() {
			if($('#pwd2').val() == $('#pwd').val() && $('#pwd').val() !== "") {
				var data = {
					tel: tel,
					pwd: $('#pwd2').val()
				};
				console.log(data);
				common.post('/updUser.html', data, function(res) {
					console.log(res);
					$.router.load('login.html');
				});
			}
		});

	}

	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.data('page');

		if(!obj) {
			obj = new resetPwd(e, id, $page);
		} else {
			$page.data('page', obj);
		}
		return obj;
	};
})