define(function (require, exports) {

    //公用类
    var common = require('common');
    //菜单
    //var menu = require('menu');
    //左边菜单
    var leftmenu = require('leftmenu');
    //获取用户ID
    var locuid = localStorage.getItem('userid');

    var examlist = function (e, id, page) {
        var that = this;
        this.page = page;//页面

        this.veiwlist = page.find('#veiwlist');

        this.screen = page.find('#screen');

        var scrdata = {page: 1, row: 20, userid: locuid};
        var scrdowndata = {userid: locuid};

        $(document).on("click", '.icon-menu', function () {
            $.openPanel("#panel-screen");
        });

        $('#scrlist li').off('click').on('click', function () {
            var _index = $(this).index();
            $('#scrlist li').removeClass('active');
            $(this).addClass('active');
            $('#btnscr').attr('sid', _index);
        });
		
		$("#my_courselist").click(function(){
			localStorage.setItem("my_courselist",true)
			location.href="../course/list.html"
		})
		
		$("#my_test").click(function(){
			localStorage.setItem("my_test",true)
			location.href="../exer/list.html"
		})
		
		
        $('#btnscr').off('click').on('click', function () {
            var _index = $(this).attr('sid');

            switch (_index) {
                case '0':
                    scrdata = {page: 1, row: 20, userid: locuid};
                    scrdowndata = {userid: locuid};
                    //页面加载
                    that.PageLoad(scrdata, scrdowndata);
                    $.closePanel('#panel-screen');
                    break;
                case '1':
                    scrdata = {page: 1, row: 20, userid: locuid, ksStatusId: 4};
                    scrdowndata = {userid: locuid, ksStatusId: 4};
                    //页面加载
                    that.PageLoad(scrdata, scrdowndata);
                    $.closePanel('#panel-screen');
                    break;
                case '2':
                    scrdata = {page: 1, row: 20, userid: locuid, ksStatusId: 5};
                    scrdowndata = {userid: locuid, ksStatusId: 5};
                    //页面加载
                    that.PageLoad(scrdata, scrdowndata);
                    $.closePanel('#panel-screen');
                    break;
                case '3':
                    scrdata = {page: 1, row: 20, userid: locuid, ksStatusId: 1};
                    scrdowndata = {userid: locuid, ksStatusId: 1};
                    //页面加载
                    that.PageLoad(scrdata, scrdowndata);
                    $.closePanel('#panel-screen');
                    break;
                case '4':
                    scrdata = {page: 1, row: 20, userid: locuid, ksStatusId: 2};
                    scrdowndata = {userid: locuid, ksStatusId: 2};
                    //页面加载
                    that.PageLoad(scrdata, scrdowndata);
                    $.closePanel('#panel-screen');
                    break;
                case '5':
                    scrdata = {page: 1, row: 20, userid: locuid, ksStatusId: 3};
                    scrdowndata = {userid: locuid, ksStatusId: 3};
                    //页面加载
                    that.PageLoad(scrdata, scrdowndata);
                    $.closePanel('#panel-screen');
                    break;
            }
        });
        
        //侧栏菜单
        if (locuid == null) {
            this.page.find('.open-panel').on('click', function () {
                $.toast('更多功能在登录之后回来');
                setTimeout(function () {
                    $.router.load('../index.html');
                }, 3000);
            });
        } else {
          leftmenu.showmenu(this.page);
        }
        //页面加载
        this.PageLoad(scrdata, scrdowndata);

        //菜单
        //menu.showmenu(this.page, '1');
    };

    //页面加载
    examlist.prototype.PageLoad = function (scrdata, scrdowndata) {
        var that = this;
        var html = [];

        //在线测试
        common.post('/getExam.html', scrdata, function (res) {
            var html = [];

            if (res.total == 0) {
                that.veiwlist.html('<div class="nomsg">还没有考试</div>');
            } else {
                for (var x = 0; x < res.total; x++) {
                    var item = res.rows[x];

                    if (item) {
                        html.push('<li class="bgwirte" ksid="' + item.ksid + '">');
                        html.push('<a href="item.html?uuid=' + item.uuid + '&ksid=' + item.ksid + '">');
                        html.push('<div class="item-content item-link">');
                        html.push('<div class="item-inner">');
                        html.push('<div class="item-title">考试名称：' + item.name + '</div>');
                        if (item.endTm && item.beginTm) {
                            html.push('<div class="item-subtitle icon-time">' + item.beginTm + ' - ' + item.endTm + '</div>');
                        } else {
                            html.push('<div class="item-subtitle icon-time">随到随考</div>');
                        }
                        html.push('<div class="item-title-row">');
                        html.push('<div class="item-subtitle icon-class">总分：' + item.totalscore + '</div>');

                        if (item.tmSec == 'yjs' && item.ksStatus == 0) {
                            //整场考试时间到期
                            html.push('<div class="item-subtitle end icon-status">已结束</div>');
                        } else {
                            // 整场考试中
                            if (locuid == 'undefined' || locuid == null) {
                                //未报名 橙色报名申请按钮
                                html.push('<div class="item-subtitle sign icon-status">报名申请</div>');
                            } else if (item.signupFlag != 'undefined' && item.signupFlag == 0 || item.signupFlag == 2) {
                                //审核中 0审核中 2是审核不通过 报名审核中按钮（颜色按反馈文档）
                                html.push('<div class="item-subtitle error icon-status">报名审核中</div>');
                            } else if (item.state != 'undefined' && item.state == 2) {
                                //参加考试 绿色参加考试按钮
                                html.push('<div class="item-subtitle free icon-status">参加考试</div>');
                            } else if (item.state != 'undefined' && item.state == 3) {
                                //正在考试中 蓝色考试中按钮
                                html.push('<div class="item-subtitle nomal icon-status">考试中</div>');
                            } else if (item.state != 'undefined' && item.state > 3) {
                                if (item.overState == 1) {
                                    //及格或次数达到上限不再考试结束
                                    html.push('<div class="item-subtitle end icon-status">已结束</div>');
                                } else {
                                    //参加考试
                                    html.push('<div class="item-subtitle free icon-status">参加考试</div>');
                                }
                            } else {
                                //已交卷 考试结束
                                html.push('<div class="item-subtitle end icon-status">已结束</div>');
                            }
                        }

                        html.push('</div>');
                        html.push('</div>');
                        html.push('</div>');
                        html.push('</a>');
                        html.push('</li>');
                    }
                }

                //添加新条目
                that.veiwlist.html(html.join(''));

            }

            that.DorpDownLoad(scrdowndata);

        });
    };

    //下拉加载
    examlist.prototype.DorpDownLoad = function (scrdowndata) {
        var that = this;
        // 加载flag
        var loading = false;
        // 最多可加载的条目
        var maxItems = 1000;

        // 每次加载添加多少条目
        var itemsPerLoad = 20;

        // 上次加载的序号
        var lastIndex = 20;

        function addItems(number, lastIndex) {
            common.get('/getExam.html', scrdowndata, function (res) {
                var dorphtml = [];

                if (res.length == 0) {
                    that.veiwlist.html('<div class="nomsg">还没有考试</div>');
                } else {
                    if (res.length > 20) {
                        // 生成新条目的HTML
                        for (var i = lastIndex + 1; i <= lastIndex + number; i++) {
                            var item = res.rows[i];

                            dorphtml.push('<li class="bgwirte" ksid="' + item.ksid + '">');
                            dorphtml.push('<a href="item.html?uuid=' + item.uuid + '&ksid=' + item.ksid + '">');
                            dorphtml.push('<div class="item-content item-link">');
                            dorphtml.push('<div class="item-inner">');
                            dorphtml.push('<div class="item-title">' + item.name + '</div>');
                            if (item.endTm && item.beginTm) {
                                dorphtml.push('<div class="item-subtitle icon-time">' + item.beginTm + ' - ' + item.endTm + '</div>');
                            } else {
                                dorphtml.push('<div class="item-subtitle icon-time">随到随考</div>');
                            }
                            dorphtml.push('<div class="item-title-row">');
                            dorphtml.push('<div class="item-subtitle icon-class">总分：' + item.totalscore + '</div>');

                            //TODO：判断考试状态,用户是否可以参加考试
                            dorphtml.push('<div class="item-subtitle free icon-status">参加考试</div>');

                            dorphtml.push('</div>');
                            dorphtml.push('</div>');
                            dorphtml.push('</div>');
                            dorphtml.push('</a>');
                            dorphtml.push('</li>');
                        }

                        // 添加新条目
                        that.veiwlist.append(dorphtml.join(''));

                        that.isfirst = false;
                    }
                }
            });
        }

        //预先加载20条
        addItems(itemsPerLoad, 0);

        // 注册'infinite'事件处理函数
        $(document).on('infinite', '.infinite-scroll', function () {

            // 如果正在加载，则退出
            if (loading) return;

            // 设置flag
            loading = true;

            // 模拟1s的加载过程
            setTimeout(function () {
                // 重置加载flag
                loading = false;

                if (lastIndex >= maxItems) {
                    // 加载完毕，则注销无限加载事件，以防不必要的加载
                    $.detachInfiniteScroll($('.infinite-scroll'));
                    return;
                }

                // 添加新条目
                if (that.tab2.hasClass('active')) {
                    addItems(itemsPerLoad, lastIndex);
                }
                // 更新最后加载的序号
                lastIndex = that.veiwlist.find('li').length;
                //容器发生改变,如果是js滚动，需要刷新滚动
                $.refreshScroller();
            }, 1000);
        });
    };

    exports.init = function (e, id, page) {

        var $page = $(page);

        var obj = $page.data('page');

        if (!obj) {
            obj = new examlist(e, id, $page);
        } else {
            $page.data('page', obj);
        }
        return obj;
    };
})
;