jQuery = Zepto;
var alias = {
    'common': 'common',
    //'menu': 'menu',
    'leftmenu' :'leftmenu',

    'login': 'login/login',
    'register': 'login/register',
    'forgotpwd': 'login/forgotpwd',
    'resetPwd': 'login/resetPwd',

    'courselist': 'course/list',
    'coursetest': 'course/test',
    'courseitem': 'course/item',
    'courselearn': 'course/learn',
    'mycourse':'course/mylist',

    'examlist': 'exam/list',
    'examitem': 'exam/item',
    'examtest': 'exam/test',
    'examylist': 'exam/mylist',

    'scorelist': 'score/list',
    'scoreitem': 'score/item',

    'exerlist': 'exer/list',
    'exertest': 'exer/test',
    'exermylist': 'exer/mylist',

    'meour': 'me/me',
    'message': 'me/message',
    'meedit': 'me/edit',
    'my':'me/my',
    
    'word':'application/word',
    'wordPrictise':'application/wordPrictise',
    'wordClassify':'application/classify',
    'wordTest':'application/wordTest',
    'wrongWord':'application/wrong',
    'apply':'application/apply',
    
    'listen':'audiovisual/listen',
    'listenUnit':'audiovisual/listenUnit',
    'listenWords':'audiovisual/listenWords',
    'listening':'audiovisual/listening',
    'listenAndRead':'audiovisual/listenAndRead',
    'rolePlay':'audiovisual/rolePlay',
    'countDown':'audiovisual/countDown',
    'playVideo':'audiovisual/playVideo'

};
seajs.config({
    base: 'module',
    alias: alias,
    map: [['.js', '.js?v=' + new Date().getTime()]]
});

//101.200.236.161:8082
var base = localStorage.getItem('base');
var baseURL = base + '/mobileMta';

$(function () {
    //显示状态栏,不重叠
    document.addEventListener("deviceready", function () {
        if ($.device.ios == true) {
            window.StatusBar.styleDefault();
        }
    }, false);

    //设置IOS手机状态栏默认主色
    try {
        if ($.device.ios == true) {
            //配置好颜色
            StatusBar.backgroundColorByHexString("#13bcec");
        }
    } catch (e) {
    }

    //欢迎页面
    $(document).on("pageInit", "#index", function (e, id, page) {
        seajs.use('welcome', function (l) {
            l.init(e, id, page);
        });
    });

    //登录
    $(document).on("pageInit", "#login", function (e, id, page) {
        seajs.use('login', function (l) {
            l.init(e, id, page);
        });
    });

    //注册
    $(document).on("pageInit", "#register", function (e, id, page) {
        seajs.use('register', function (l) {
        	
            l.init(e, id, page);
        });
    });
    
      //忘记密码
    $(document).on("pageInit", "#forgotpwd", function (e, id, page) {
        seajs.use('forgotpwd', function (l) {      	
            l.init(e, id, page);
        });
    });
    
       //重置密码
    $(document).on("pageInit", "#resetPwd", function (e, id, page) {
        seajs.use('resetPwd', function (l) {      	
            l.init(e, id, page);
        });
    });

    //课程
    $(document).on("pageInit", "#courselist", function (e, id, page) {
        seajs.use('courselist', function (l) {
            l.init(e, id, page);
        });
    });

    //课程详细
    $(document).on("pageInit", "#courseitem", function (e, id, page) {
        seajs.use('courseitem', function (l) {
            l.init(e, id, page);
        });
    });

    //课程播放
    $(document).on("pageInit", "#courselearn", function (e, id, page) {
        seajs.use('courselearn', function (l) {
            l.init(e, id, page);
        });
    });

    //课程测试
    $(document).on("pageInit", "#coursetest", function (e, id, page) {
        seajs.use('coursetest', function (l) {
            l.init(e, id, page);
        });
    });

    //考试列表
    $(document).on("pageInit", "#examlist", function (e, id, page) {
        seajs.use('examlist', function (l) {
            l.init(e, id, page);
        });
    });

    //考试信息
    $(document).on("pageInit", "#examitem", function (e, id, page) {
        seajs.use('examitem', function (l) {
            l.init(e, id, page);
        });
    });

    //考试试卷
    $(document).on("pageInit", "#examtest", function (e, id, page) {
        seajs.use('examtest', function (l) {
            l.init(e, id, page);
        });
    });

    //成绩列表
    $(document).on("pageInit", "#scorelist", function (e, id, page) {
        seajs.use('scorelist', function (l) {
            l.init(e, id, page);
        });
    });

    //成绩详细
    $(document).on("pageInit", "#scoreitem", function (e, id, page) {
        seajs.use('scoreitem', function (l) {
            l.init(e, id, page);
        });
    });

    //练习列表
    $(document).on("pageInit", "#exerlist", function (e, id, page) {
        seajs.use('exerlist', function (l) {
            l.init(e, id, page);
        });
    });

    //错题练习
    $(document).on("pageInit", "#exertest", function (e, id, page) {
        seajs.use('exertest', function (l) {
            l.init(e, id, page);
        });
    });
    
    //应用
    $(document).on("pageInit", "#apply", function (e, id, page) {
        seajs.use('apply', function (l) {
            l.init(e, id, page);
        });
    });
    
    //个人中心
    $(document).on("pageInit", "#my", function (e, id, page) {
        seajs.use('my', function (l) {
            l.init(e, id, page);
        });
    });
    
    //设置
    $(document).on("pageInit", "#meour", function (e, id, page) {
        seajs.use('meour', function (l) {
            l.init(e, id, page);
        });
    });

    //我的信息修改
    $(document).on("pageInit", "#meedit", function (e, id, page) {
        seajs.use('meedit', function (l) {
            l.init(e, id, page);
        });
    });
    
      //应用页面
    $(document).on("pageInit", "#application", function (e, id, page) {
        seajs.use('application', function (l) {
            l.init(e, id, page);
        });
    });
    
      //背单词页面
    $(document).on("pageInit", "#word", function (e, id, page) {
        seajs.use('word', function (l) {
            l.init(e, id, page);
        });
    });
    //单词练习页面
     $(document).on("pageInit", "#wordPrictise", function (e, id, page) {
        seajs.use('wordPrictise', function (l) {
            l.init(e, id, page);
        });
    });
    $(document).on("pageInit", "#wordTest", function (e, id, page) {
        seajs.use('wordTest', function (l) {
            l.init(e, id, page);
        });
    });

     //单词分类页面
     $(document).on("pageInit", "#wordClassify", function (e, id, page) {
        seajs.use('wordClassify', function (l) {
            l.init(e, id, page);
        });
    });

      //视听说
    $(document).on("pageInit", "#listen", function (e, id, page) {
        seajs.use('listen', function (l) {
            l.init(e, id, page);
        });
    });
    //视听说-单元
    $(document).on("pageInit", "#listenUnit", function (e, id, page) {
        seajs.use('listenUnit', function (l) {
            l.init(e, id, page);
        });
    });
    //视听说-单词
    $(document).on("pageInit", "#listenWords", function (e, id, page) {
        seajs.use('listenWords', function (l) {
            l.init(e, id, page);
        });
    });
    //视听说-单词播放
    $(document).on("pageInit", "#listening", function (e, id, page) {
        seajs.use('listening', function (l) {
            l.init(e, id, page);
        });
    });
    
        //视听说-听读听
    $(document).on("pageInit", "#listenAndRead", function (e, id, page) {
        seajs.use('listenAndRead', function (l) {
            l.init(e, id, page);
        });
    });
    
        //视听说-角色扮演
    $(document).on("pageInit", "#rolePlay", function (e, id, page) {
        seajs.use('rolePlay', function (l) {
            l.init(e, id, page);
        });
    });
    
        //视听说-倒计时页面
    $(document).on("pageInit", "#countDown", function (e, id, page) {
        seajs.use('countDown', function (l) {
            l.init(e, id, page);
        });
    });
    
      //视听说-角色扮演页面
    $(document).on("pageInit", "#playVideo", function (e, id, page) {
        seajs.use('playVideo', function (l) {
            l.init(e, id, page);
        });
    });
    //我的消息
    $(document).on("pageInit", "#message", function (e, id, page) {
        seajs.use('message', function (l) {
            l.init(e, id, page);
        });
    });

    //我的课程
    $(document).on("pageInit", "#mycourse", function (e, id, page) {
        seajs.use('mycourse', function (l) {
            l.init(e, id, page);
        });
    });
    
    //我的考试
    $(document).on("pageInit", "#examylist", function (e, id, page) {
        seajs.use('examylist', function (l) {
            l.init(e, id, page);
        });
    });
    
    //我的练习
    $(document).on("pageInit", "#exermylist", function (e, id, page) {
        seajs.use('exermylist', function (l) {
            l.init(e, id, page);
        });
    });

    //错题页面
     $(document).on("pageInit", "#wrongWord", function (e, id, page) {
        seajs.use('wrongWord', function (l) {
            l.init(e, id, page);
        });
    });

    $.init();

});
